{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE Rank2Types #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_SCC
  ( C_Node (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  , nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  , nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  , d_C_scc
  , nd_C_scc )
  where

import Basics
import qualified Curry_Prelude
import qualified Curry_RedBlackTree
import qualified Curry_SetRBT


data C_Node t0 t1
  = C_Node Curry_Prelude.C_Int (Curry_Prelude.OP_List t1) (Curry_Prelude.OP_List
    t1) t0
  | Choice_C_Node Cover ID (C_Node t0 t1) (C_Node t0 t1)
  | Choices_C_Node Cover ID [C_Node t0 t1]
  | Fail_C_Node Cover FailInfo
  | Guard_C_Node Cover Constraints (C_Node t0 t1)

instance (Show t0, Show t1) => Show (C_Node t0 t1) where
  showsPrec d (Choice_C_Node cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Node cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Node cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Node cd info) = showChar '!'
  showsPrec _ (C_Node x1 x2 x3 x4) = showString "(Node" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . (showChar ' ' .
    (shows x4 . showChar ')'))))))))

instance (Read t0, Read t1) => Read (C_Node t0 t1) where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Node x1 x2 x3 x4, r4) | (_
    , r0) <- readQualified "Data.SCC" "Node" r, (x1, r1) <- readsPrec 11 r0, (x2
    , r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <- readsPrec
    11 r3]) s

instance NonDet (C_Node t0 t1) where
  choiceCons = Choice_C_Node
  choicesCons = Choices_C_Node
  failCons = Fail_C_Node
  guardCons = Guard_C_Node
  try (Choice_C_Node cd i x y) = tryChoice cd i x y
  try (Choices_C_Node cd i xs) = tryChoices cd i xs
  try (Fail_C_Node cd info) = Fail cd info
  try (Guard_C_Node cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Node cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Node cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Node cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Node cd i _) = error
    ("Data.SCC.Node.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Node cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Node cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Generable t0, Generable t1) => Generable (C_Node t0 t1) where
  generate s c = Choices_C_Node c (freeID [4] s) [C_Node (generate (leftSupply
    (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate
    (leftSupply (rightSupply s)) c) (generate (rightSupply (rightSupply s)) c)]

instance (NormalForm t0, NormalForm t1) => NormalForm (C_Node t0 t1) where
  ($!!) cont (C_Node x1 x2 x3 x4) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> cont (C_Node y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Node cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Node cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Node cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Node cd info) _ _ = failCons cd info
  ($##) cont (C_Node x1 x2 x3 x4) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> ($##) (\y4 d cs -> cont (C_Node y1 y2 y3 y4) d cs) x4 d
    cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Node cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Node cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Node cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Node cd info) _ _ = failCons cd info
  showCons (C_Node _ _ _ _) = "Data.SCC.Node _ _ _ _"
  showCons x = error ("Data.SCC.Node.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Node x1 x2 x3 x4) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> cont (C_Node y1 y2 y3 y4)) x4) x3) x2) x1
  searchNF _ _ x = error ("Data.SCC.Node.searchNF: no constructor: " ++ show x)

instance (Unifiable t0, Unifiable t1) => Unifiable (C_Node t0 t1) where
  (=.=) (C_Node x1 x2 x3 x4) (C_Node y1 y2 y3 y4) d cs = (&) ((=:=) x1 y1 d cs)
    ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((=:=) x4 y4 d cs) d cs) d
    cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Node x1 x2 x3 x4) (C_Node y1 y2 y3 y4) d cs = (&) ((=:<=) x1 y1 d
    cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((=:<=) x4 y4 d cs) d
    cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Node x3 x4 x5 x6) = (i :=: ChooseN 0 4) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (leftID (rightID
    i)) x5, bind cd (rightID (rightID i)) x6]
  bind d i (Choice_C_Node cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Node cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Node cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Node cd i _) = error
    ("Data.SCC.Node.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Node cd info) = [Unsolvable info]
  bind d i (Guard_C_Node cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Node x3 x4 x5 x6) = (i :=: ChooseN 0 4) : [leftID (leftID
    i) :=: LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), leftID (rightID i) :=:
    LazyBind (lazyBind cd (leftID (rightID i)) x5), rightID (rightID i) :=:
    LazyBind (lazyBind cd (rightID (rightID i)) x6)]
  lazyBind d i (Choice_C_Node cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Node cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Node cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Node cd i _) = error
    ("Data.SCC.Node.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Node cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Node cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0, Curry t1) => Curry (C_Node t0 t1) where

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq (C_Node t0 t1)
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 cd cs =
  Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
  (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1
  x2))
  (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  x1 x2 cd cs)

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq (C_Node t0 t1)
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX (wrapNX id)
  (acceptCs id
  (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  x1 x2)))
  (nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
  x1 x2 s0 cd cs)

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> C_Node t0 t1 -> C_Node t0 t1
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 x3 x4 cd cs =
  case x3 of
  C_Node x5 x6 x7 x8 -> d_C__case_4 x8 x1 x7 x2 x6 x5 x4 cd cs
  Choice_C_Node d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
    x1 x2 l x4 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
    x1 x2 r x4 cd cs)
  Choices_C_Node d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
    x1 x2 z x4 cd cs) xs
  Guard_C_Node d c e -> guardCons d c
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
    x1 x2 e x4 cd $! addCs c cs)
  Fail_C_Node d info -> failCons d (traceFail
    "Data.SCC._impl#==#Prelude.Eq#Data.SCC.Node" [show x1, show x2, show x3
    , show x4] info)
  _ -> failCons cd (consFail "Data.SCC._impl#==#Prelude.Eq#Data.SCC.Node"
    (showCons x3))

nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> C_Node t0 t1 -> C_Node t0 t1
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 x3 x4 s cd cs =
  case x3 of
  C_Node x5 x6 x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_4 x8 x1 x7 x2 x6 x5 x4 s0 cd cs
  Choice_C_Node d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
    x1 x2 l x4 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
    x1 x2 r x4 s cd cs)
  Choices_C_Node d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
    x1 x2 z x4 s cd cs) xs
  Guard_C_Node d c e -> guardCons d c
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node
    x1 x2 e x4 s cd $! addCs c cs)
  Fail_C_Node d info -> failCons d (traceFail
    "Data.SCC._impl#==#Prelude.Eq#Data.SCC.Node" [show x1, show x2, show x3
    , show x4] info)
  _ -> failCons cd (consFail "Data.SCC._impl#==#Prelude.Eq#Data.SCC.Node"
    (showCons x3))

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Cover -> ConstStore -> C_Node t0
  t1 -> Cover -> ConstStore -> C_Node t0 t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 cd cs))

nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> IDSupply -> Cover -> ConstStore
  -> Func (C_Node t0 t1) (Func (C_Node t0 t1) Curry_Prelude.C_Bool)
nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 s cd cs =
  let s0 = s
  in s0 `seq` wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 s0 cd
  cs)))

d_C_cmpNode :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Node t0 t1 -> C_Node t0 t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_cmpNode x1 x2 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
  cd cs) (d_C_key x1 cd cs) cd cs) (d_C_key x2 cd cs) cd cs

d_C_key :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Node t0 t1 -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_key x1 cd cs = case x1 of
  C_Node x2 x3 x4 x5 -> x2
  Choice_C_Node d i l r -> narrow d i (d_C_key l cd cs) (d_C_key r cd cs)
  Choices_C_Node d i xs -> narrows cs d i (\z -> d_C_key z cd cs) xs
  Guard_C_Node d c e -> guardCons d c (d_C_key e cd $! addCs c cs)
  Fail_C_Node d info -> failCons d (traceFail "Data.SCC.key" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.key" (showCons x1))

d_C_bvs :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Node t0 t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_C_bvs x1 cd cs = case x1 of
  C_Node x2 x3 x4 x5 -> x3
  Choice_C_Node d i l r -> narrow d i (d_C_bvs l cd cs) (d_C_bvs r cd cs)
  Choices_C_Node d i xs -> narrows cs d i (\z -> d_C_bvs z cd cs) xs
  Guard_C_Node d c e -> guardCons d c (d_C_bvs e cd $! addCs c cs)
  Fail_C_Node d info -> failCons d (traceFail "Data.SCC.bvs" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.bvs" (showCons x1))

d_C_fvs :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Node t0 t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_C_fvs x1 cd cs = case x1 of
  C_Node x2 x3 x4 x5 -> x4
  Choice_C_Node d i l r -> narrow d i (d_C_fvs l cd cs) (d_C_fvs r cd cs)
  Choices_C_Node d i xs -> narrows cs d i (\z -> d_C_fvs z cd cs) xs
  Guard_C_Node d c e -> guardCons d c (d_C_fvs e cd $! addCs c cs)
  Fail_C_Node d info -> failCons d (traceFail "Data.SCC.fvs" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.fvs" (showCons x1))

d_C_node :: forall t1 t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => C_Node t0 t1 -> Cover -> ConstStore -> t0
d_C_node x1 cd cs = case x1 of
  C_Node x2 x3 x4 x5 -> x5
  Choice_C_Node d i l r -> narrow d i (d_C_node l cd cs) (d_C_node r cd cs)
  Choices_C_Node d i xs -> narrows cs d i (\z -> d_C_node z cd cs) xs
  Guard_C_Node d c e -> guardCons d c (d_C_node e cd $! addCs c cs)
  Fail_C_Node d info -> failCons d (traceFail "Data.SCC.node" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.node" (showCons x1))

d_C_scc :: forall t1 t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List t0)
d_C_scc x1 x2 x3 x4 cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
  (Curry_Prelude.d_C_map d_C_node)) (Curry_Prelude.d_OP_dot (d_C_tsort' x1 x2)
  (Curry_Prelude.d_OP_dot (d_C_tsort x1 x2) (Curry_Prelude.d_C_zipWith (acceptCs
  id (d_OP_scc_dot_wrap_dot_24 x3 x4)) (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int
  cd cs) (Curry_Prelude.C_Int (0)) cd cs)) cd cs) cd cs) cd cs

nd_C_scc :: forall t1 t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Func t0 (Curry_Prelude.OP_List
  t1) -> Func t0 (Curry_Prelude.OP_List t1) -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t0))
nd_C_scc x1 x2 x3 x4 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s4 = rightSupply s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Prelude.nd_C_map (wrapNX id (Curry_Prelude.nd_C_map (wrapDX id
  d_C_node))))) (let s3 = leftSupply s4
                     s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (nd_C_tsort' x1 x2))
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (nd_C_tsort x1 x2))
  (wrapNX id (Curry_Prelude.nd_C_zipWith (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_scc_dot_wrap_dot_24 x3 x4))) (Curry_Prelude.nd_C_apply (wrapDX id
  (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int
  cd cs)) (Curry_Prelude.C_Int (0)) s0 cd cs))) s1 cd cs)) s3 cd cs)) s5 cd cs))

d_OP_scc_dot_wrap_dot_24 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1) -> (t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1) -> Curry_Prelude.C_Int -> t0 -> Cover
  -> ConstStore -> C_Node t0 t1
d_OP_scc_dot_wrap_dot_24 x1 x2 x3 x4 cd cs = C_Node x3 (Curry_Prelude.d_C_apply
  x1 x4 cd cs) (Curry_Prelude.d_C_apply x2 x4 cd cs) x4

nd_OP_scc_dot_wrap_dot_24 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func t0 (Curry_Prelude.OP_List t1) -> Func t0
  (Curry_Prelude.OP_List t1) -> Curry_Prelude.C_Int -> t0 -> IDSupply -> Cover
  -> ConstStore -> C_Node t0 t1
nd_OP_scc_dot_wrap_dot_24 x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` C_Node x3 (Curry_Prelude.nd_C_apply x1 x4 s0 cd cs)
  (Curry_Prelude.nd_C_apply x2 x4 s1 cd cs) x4))

d_C_tsort :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Cover -> ConstStore -> Curry_Prelude.OP_List (C_Node t0 t1)
d_C_tsort x1 x2 x3 cd cs = Curry_Prelude.d_C_snd (d_OP_tsort_dot_dfs_dot_28 x3
  x2 x3 (Curry_Prelude.d_C_apply (Curry_SetRBT.d_C_emptySetRBT
  (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 cd cs)
  cd cs) (acceptCs id d_C_cmpNode) cd cs) Curry_Prelude.OP_List cd cs) cd cs

nd_C_tsort :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List (C_Node t0 t1)
nd_C_tsort x1 x2 x3 s cd cs = let s6 = s
  in s6 `seq` Curry_Prelude.d_C_snd (let s5 = leftSupply s6
                                         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_OP_tsort_dot_dfs_dot_28 x3 x2 x3 (let s3 = leftSupply
                                                                   s4
                                                                 s2 = rightSupply
                                                                   s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_SetRBT.nd_C_emptySetRBT
  (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 s0 cd
  cs) s1 cd cs)) (wrapDX (wrapDX id) (acceptCs id d_C_cmpNode)) s3 cd cs))
  Curry_Prelude.OP_List s5 cd cs)) cd cs

d_OP_tsort_dot_dfs_dot_28 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
  -> Curry_Prelude.OP_List (C_Node t0 t1) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1))
  (Curry_Prelude.OP_List (C_Node t0 t1))
d_OP_tsort_dot_dfs_dot_28 x1 x2 x3 x4 x5 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x4 x5
  Curry_Prelude.OP_Cons x6 x7 -> let x8 = d_OP_tsort_dot_dfs_dot_28 x1 x2
                                       (d_OP_tsort_dot_dfs_dot_28_dot_defs_dot_32
                                       x1 x2 x6 cd cs) (Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_apply
                                       (Curry_SetRBT.d_C_insertRBT cd cs) x6 cd
                                       cs) x4 cd cs) x5 cd cs
                                     x9 = d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick
                                       x8 cd cs
                                     x10 = d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick
                                       x8 cd cs
    in d_C__case_3 x4 x6 x10 x9 x7 x2 x1 x5 (Curry_Prelude.d_C_apply
    (Curry_SetRBT.d_C_elemRBT x6 cd cs) x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_OP_tsort_dot_dfs_dot_28
    x1 x2 l x4 x5 cd cs) (d_OP_tsort_dot_dfs_dot_28 x1 x2 r x4 x5 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_tsort_dot_dfs_dot_28 x1 x2 z x4 x5 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_OP_tsort_dot_dfs_dot_28
    x1 x2 e x4 x5 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.SCC.tsort.dfs.28" [show x1, show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.SCC.tsort.dfs.28" (showCons x3))

nd_OP_tsort_dot_dfs_dot_28 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
  -> Curry_Prelude.OP_List (C_Node t0 t1) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1))
  (Curry_Prelude.OP_List (C_Node t0 t1))
nd_OP_tsort_dot_dfs_dot_28 x1 x2 x3 x4 x5 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x4 x5
  Curry_Prelude.OP_Cons x6 x7 -> let s16 = s
    in s16 `seq` (let s17 = leftSupply s16
                      s18 = rightSupply s16
                      s7 = leftSupply s17
                      s9 = rightSupply s17
                      s10 = leftSupply s18
                      s15 = rightSupply s18
    in s17 `seq` (s18 `seq` (s7 `seq` (s9 `seq` (s10 `seq` (s15 `seq`
    (let x8 = let s6 = leftSupply s7
                  s8 = rightSupply s7
                  s0 = leftSupply s8
                  s5 = rightSupply s8
           in s6 `seq` (s8 `seq` (s0 `seq` (s5 `seq` nd_OP_tsort_dot_dfs_dot_28
           x1 x2 (nd_OP_tsort_dot_dfs_dot_28_dot_defs_dot_32 x1 x2 x6 s0 cd cs)
           (let s4 = leftSupply s5
                s3 = rightSupply s5
           in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply
                                                                 s3
                                                               s1 = rightSupply
                                                                 s3
           in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
           (Curry_SetRBT.nd_C_insertRBT s1 cd cs) x6 s2 cd cs)) x4 s4 cd cs)) x5
           s6 cd cs)))
         x9 = nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick
           x8 s9 cd cs
         x10 = nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick
           x8 s10 cd cs
    in let s14 = leftSupply s15
           s13 = rightSupply s15
    in s14 `seq` (s13 `seq` nd_C__case_3 x4 x6 x10 x9 x7 x2 x1 x5
    (let s12 = leftSupply s13
         s11 = rightSupply s13
    in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (Curry_SetRBT.nd_C_elemRBT
    x6 s11 cd cs) x4 s12 cd cs)) s14 cd cs))))))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_OP_tsort_dot_dfs_dot_28
    x1 x2 l x4 x5 s cd cs) (nd_OP_tsort_dot_dfs_dot_28 x1 x2 r x4 x5 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_tsort_dot_dfs_dot_28 x1 x2 z x4 x5 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_OP_tsort_dot_dfs_dot_28
    x1 x2 e x4 x5 s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.SCC.tsort.dfs.28" [show x1, show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.SCC.tsort.dfs.28" (showCons x3))

d_OP_tsort_dot_dfs_dot_28_dot_defs_dot_32 :: forall t2 t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> C_Node t2 t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (C_Node t0 t1)
d_OP_tsort_dot_dfs_dot_28_dot_defs_dot_32 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_any
  (Curry_Prelude.d_C_flip (Curry_Prelude.d_C_elem x2) (d_C_fvs x3 cd cs)) cd cs)
  d_C_bvs cd cs) x1 cd cs

nd_OP_tsort_dot_dfs_dot_28_dot_defs_dot_32 :: forall t2 t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> C_Node t2 t1 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (C_Node t0 t1)
nd_OP_tsort_dot_dfs_dot_28_dot_defs_dot_32 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_filter (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (Curry_Prelude.nd_C_any (wrapNX
  id (Curry_Prelude.nd_C_flip (wrapNX id (Curry_Prelude.nd_C_elem x2)) (d_C_fvs
  x3 cd cs))) s0 cd cs) (wrapDX id d_C_bvs) s1 cd cs)) x1 s3 cd cs))

d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0
  t1)) (Curry_Prelude.OP_List (C_Node t0 t1)) -> Cover -> ConstStore
  -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick l cd cs)
    (d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.SCC.tsort.dfs.28._#selFP2#marks'" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.tsort.dfs.28._#selFP2#marks'" (showCons
    x1))

nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0
  t1)) (Curry_Prelude.OP_List (C_Node t0 t1)) -> IDSupply -> Cover -> ConstStore
  -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick l s cd
    cs) (nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick r s
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP2_hash_marks_tick e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.SCC.tsort.dfs.28._#selFP2#marks'" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.tsort.dfs.28._#selFP2#marks'" (showCons
    x1))

d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0
  t1)) (Curry_Prelude.OP_List (C_Node t0 t1)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_Node t0 t1)
d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick l cd cs)
    (d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.SCC.tsort.dfs.28._#selFP3#stack'" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.tsort.dfs.28._#selFP3#stack'" (showCons
    x1))

nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0
  t1)) (Curry_Prelude.OP_List (C_Node t0 t1)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (C_Node t0 t1)
nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick l s cd
    cs) (nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick r s
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_tsort_dot_dfs_dot_28_dot_uscore_hash_selFP3_hash_stack_tick e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.SCC.tsort.dfs.28._#selFP3#stack'" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.tsort.dfs.28._#selFP3#stack'" (showCons
    x1))

d_C_tsort' :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  (C_Node t0 t1))
d_C_tsort' x1 x2 x3 cd cs = Curry_Prelude.d_C_snd
  (d_OP_tsort_tick_dot_dfs_dot_37 x3 x2 x3 (Curry_Prelude.d_C_apply
  (Curry_SetRBT.d_C_emptySetRBT
  (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 cd cs)
  cd cs) (acceptCs id d_C_cmpNode) cd cs) Curry_Prelude.OP_List cd cs) cd cs

nd_C_tsort' :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (C_Node t0 t1))
nd_C_tsort' x1 x2 x3 s cd cs = let s6 = s
  in s6 `seq` Curry_Prelude.d_C_snd (let s5 = leftSupply s6
                                         s4 = rightSupply s6
  in s5 `seq` (s4 `seq` nd_OP_tsort_tick_dot_dfs_dot_37 x3 x2 x3
  (let s3 = leftSupply s4
       s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_SetRBT.nd_C_emptySetRBT
  (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_SCC_dot_Node x1 x2 s0 cd
  cs) s1 cd cs)) (wrapDX (wrapDX id) (acceptCs id d_C_cmpNode)) s3 cd cs))
  Curry_Prelude.OP_List s5 cd cs)) cd cs

d_OP_tsort_tick_dot_dfs_dot_37 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree
  (C_Node t0 t1)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)))
d_OP_tsort_tick_dot_dfs_dot_37 x1 x2 x3 x4 x5 cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x4 x5
  Curry_Prelude.OP_Cons x6 x7 -> let x8 = d_OP_tsort_tick_dot_dfs_dot_37 x1 x2
                                       (d_OP_tsort_tick_dot_dfs_dot_37_dot_uses_dot_41
                                       x1 x2 x6 cd cs) (Curry_Prelude.d_C_apply
                                       (Curry_Prelude.d_C_apply
                                       (Curry_SetRBT.d_C_insertRBT cd cs) x6 cd
                                       cs) x4 cd cs) Curry_Prelude.OP_List cd cs
                                     x9 = d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick
                                       x8 cd cs
                                     x10 = d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick
                                       x8 cd cs
    in d_C__case_1 x4 x6 x5 x10 x9 x7 x2 x1 (Curry_Prelude.d_C_apply
    (Curry_SetRBT.d_C_elemRBT x6 cd cs) x4 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_tsort_tick_dot_dfs_dot_37 x1 x2 l x4 x5 cd cs)
    (d_OP_tsort_tick_dot_dfs_dot_37 x1 x2 r x4 x5 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_tsort_tick_dot_dfs_dot_37 x1 x2 z x4 x5 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_tsort_tick_dot_dfs_dot_37 x1 x2 e x4 x5 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.SCC.tsort'.dfs.37" [show x1, show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.SCC.tsort'.dfs.37" (showCons x3))

nd_OP_tsort_tick_dot_dfs_dot_37 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)) -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (C_Node t0 t1)))
nd_OP_tsort_tick_dot_dfs_dot_37 x1 x2 x3 x4 x5 s cd cs = case x3 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 x4 x5
  Curry_Prelude.OP_Cons x6 x7 -> let s16 = s
    in s16 `seq` (let s17 = leftSupply s16
                      s18 = rightSupply s16
                      s7 = leftSupply s17
                      s9 = rightSupply s17
                      s10 = leftSupply s18
                      s15 = rightSupply s18
    in s17 `seq` (s18 `seq` (s7 `seq` (s9 `seq` (s10 `seq` (s15 `seq`
    (let x8 = let s6 = leftSupply s7
                  s8 = rightSupply s7
                  s0 = leftSupply s8
                  s5 = rightSupply s8
           in s6 `seq` (s8 `seq` (s0 `seq` (s5 `seq`
           nd_OP_tsort_tick_dot_dfs_dot_37 x1 x2
           (nd_OP_tsort_tick_dot_dfs_dot_37_dot_uses_dot_41 x1 x2 x6 s0 cd cs)
           (let s4 = leftSupply s5
                s3 = rightSupply s5
           in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (let s2 = leftSupply
                                                                 s3
                                                               s1 = rightSupply
                                                                 s3
           in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
           (Curry_SetRBT.nd_C_insertRBT s1 cd cs) x6 s2 cd cs)) x4 s4 cd cs))
           Curry_Prelude.OP_List s6 cd cs)))
         x9 = nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick
           x8 s9 cd cs
         x10 = nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick
           x8 s10 cd cs
    in let s14 = leftSupply s15
           s13 = rightSupply s15
    in s14 `seq` (s13 `seq` nd_C__case_1 x4 x6 x5 x10 x9 x7 x2 x1
    (let s12 = leftSupply s13
         s11 = rightSupply s13
    in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (Curry_SetRBT.nd_C_elemRBT
    x6 s11 cd cs) x4 s12 cd cs)) s14 cd cs))))))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_tsort_tick_dot_dfs_dot_37 x1 x2 l x4 x5 s cd cs)
    (nd_OP_tsort_tick_dot_dfs_dot_37 x1 x2 r x4 x5 s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_tsort_tick_dot_dfs_dot_37 x1 x2 z x4 x5 s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (nd_OP_tsort_tick_dot_dfs_dot_37 x1 x2 e x4 x5 s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.SCC.tsort'.dfs.37" [show x1, show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.SCC.tsort'.dfs.37" (showCons x3))

d_OP_tsort_tick_dot_dfs_dot_37_dot_uses_dot_41 :: forall t2 t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> C_Node t2 t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (C_Node t0 t1)
d_OP_tsort_tick_dot_dfs_dot_37_dot_uses_dot_41 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_filter (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_any
  (Curry_Prelude.d_C_flip (Curry_Prelude.d_C_elem x2) (d_C_bvs x3 cd cs)) cd cs)
  d_C_fvs cd cs) x1 cd cs

nd_OP_tsort_tick_dot_dfs_dot_37_dot_uses_dot_41 :: forall t2 t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> C_Node t2 t1 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (C_Node t0 t1)
nd_OP_tsort_tick_dot_dfs_dot_37_dot_uses_dot_41 x1 x2 x3 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_filter (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (Curry_Prelude.nd_C_any (wrapNX
  id (Curry_Prelude.nd_C_flip (wrapNX id (Curry_Prelude.nd_C_elem x2)) (d_C_bvs
  x3 cd cs))) s0 cd cs) (wrapDX id d_C_fvs) s1 cd cs)) x1 s3 cd cs))

d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0
  t1)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))) -> Cover
  -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick l cd
    cs) (d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.SCC.tsort'.dfs.37._#selFP5#marks'" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.tsort'.dfs.37._#selFP5#marks'" (showCons
    x1))

nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0
  t1)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)))
  -> IDSupply -> Cover -> ConstStore -> Curry_RedBlackTree.C_RedBlackTree
  (C_Node t0 t1)
nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick l s
    cd cs)
    (nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick r s
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP5_hash_marks_tick e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.SCC.tsort'.dfs.37._#selFP5#marks'" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.tsort'.dfs.37._#selFP5#marks'" (showCons
    x1))

d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0
  t1)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))
d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick l cd
    cs) (d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick z cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.SCC.tsort'.dfs.37._#selFP6#stack'" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.tsort'.dfs.37._#selFP6#stack'" (showCons
    x1))

nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0
  t1)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (C_Node t0 t1))
nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick l s
    cd cs)
    (nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick r s
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_tsort_tick_dot_dfs_dot_37_dot_uscore_hash_selFP6_hash_stack_tick e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.SCC.tsort'.dfs.37._#selFP6#stack'" [show x1] info)
  _ -> failCons cd (consFail "Data.SCC.tsort'.dfs.37._#selFP6#stack'" (showCons
    x1))

d_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1) -> C_Node t0 t1
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))
  -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1) -> Curry_Prelude.OP_List
  (C_Node t0 t1) -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1
  -> Curry_Prelude.OP_List (C_Node t0 t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree
  (C_Node t0 t1)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)))
d_C__case_1 x4 x6 x5 x10 x9 x7 x2 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_OP_tsort_tick_dot_dfs_dot_37 x1 x2 x7 x4 x5 cd cs
  Curry_Prelude.C_False -> d_C__case_0 x5 x10 x6 x9 x7 x2 x1
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x4 x6 x5 x10 x9
    x7 x2 x1 l cd cs) (d_C__case_1 x4 x6 x5 x10 x9 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x4 x6
    x5 x10 x9 x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_1 x4 x6 x5 x10 x9
    x7 x2 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.SCC._case_1"
    [show x4, show x6, show x5, show x10, show x9, show x7, show x2, show x1
    , show x11] info)
  _ -> failCons cd (consFail "Data.SCC._case_1" (showCons x11))

nd_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1) -> C_Node t0 t1
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))
  -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1) -> Curry_Prelude.OP_List
  (C_Node t0 t1) -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1
  -> Curry_Prelude.OP_List (C_Node t0 t1) -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (C_Node t0 t1)))
nd_C__case_1 x4 x6 x5 x10 x9 x7 x2 x1 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tsort_tick_dot_dfs_dot_37 x1 x2 x7 x4 x5 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_0 x5 x10 x6 x9 x7 x2 x1 (Curry_Prelude.d_C_otherwise
    cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x4 x6 x5 x10
    x9 x7 x2 x1 l s cd cs) (nd_C__case_1 x4 x6 x5 x10 x9 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x4
    x6 x5 x10 x9 x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_1 x4 x6 x5 x10
    x9 x7 x2 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.SCC._case_1"
    [show x4, show x6, show x5, show x10, show x9, show x7, show x2, show x1
    , show x11] info)
  _ -> failCons cd (consFail "Data.SCC._case_1" (showCons x11))

d_C__case_0 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)) -> C_Node t0
  t1 -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
  -> Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (C_Node t0 t1)))
d_C__case_0 x5 x10 x6 x9 x7 x2 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_OP_tsort_tick_dot_dfs_dot_37 x1 x2 x7 x9
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x6 (Curry_Prelude.d_C_concat
    x10 cd cs)) x5) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x5 x10 x6 x9 x7
    x2 x1 l cd cs) (d_C__case_0 x5 x10 x6 x9 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x5
    x10 x6 x9 x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_0 x5 x10 x6 x9 x7
    x2 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.SCC._case_0"
    [show x5, show x10, show x6, show x9, show x7, show x2, show x1, show x11]
    info)
  _ -> failCons cd (consFail "Data.SCC._case_0" (showCons x11))

nd_C__case_0 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)) -> C_Node t0
  t1 -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)
  -> Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1))
  (Curry_Prelude.OP_List (Curry_Prelude.OP_List (C_Node t0 t1)))
nd_C__case_0 x5 x10 x6 x9 x7 x2 x1 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tsort_tick_dot_dfs_dot_37 x1 x2 x7 x9
    (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Cons x6 (Curry_Prelude.d_C_concat
    x10 cd cs)) x5) s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x5 x10 x6 x9
    x7 x2 x1 l s cd cs) (nd_C__case_0 x5 x10 x6 x9 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x5
    x10 x6 x9 x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_0 x5 x10 x6 x9
    x7 x2 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.SCC._case_0"
    [show x5, show x10, show x6, show x9, show x7, show x2, show x1, show x11]
    info)
  _ -> failCons cd (consFail "Data.SCC._case_0" (showCons x11))

d_C__case_3 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1) -> C_Node t0 t1
  -> Curry_Prelude.OP_List (C_Node t0 t1) -> Curry_RedBlackTree.C_RedBlackTree
  (C_Node t0 t1) -> Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Curry_Prelude.OP_List (C_Node t0 t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree
  (C_Node t0 t1)) (Curry_Prelude.OP_List (C_Node t0 t1))
d_C__case_3 x4 x6 x10 x9 x7 x2 x1 x5 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_OP_tsort_dot_dfs_dot_28 x1 x2 x7 x4 x5 cd cs
  Curry_Prelude.C_False -> d_C__case_2 x10 x6 x9 x7 x2 x1
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x4 x6 x10 x9 x7
    x2 x1 x5 l cd cs) (d_C__case_3 x4 x6 x10 x9 x7 x2 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x4 x6
    x10 x9 x7 x2 x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_3 x4 x6 x10 x9 x7
    x2 x1 x5 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.SCC._case_3"
    [show x4, show x6, show x10, show x9, show x7, show x2, show x1, show x5
    , show x11] info)
  _ -> failCons cd (consFail "Data.SCC._case_3" (showCons x11))

nd_C__case_3 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1) -> C_Node t0 t1
  -> Curry_Prelude.OP_List (C_Node t0 t1) -> Curry_RedBlackTree.C_RedBlackTree
  (C_Node t0 t1) -> Curry_Prelude.OP_List (C_Node t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List (C_Node t0
  t1) -> Curry_Prelude.OP_List (C_Node t0 t1) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)) (Curry_Prelude.OP_List
  (C_Node t0 t1))
nd_C__case_3 x4 x6 x10 x9 x7 x2 x1 x5 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tsort_dot_dfs_dot_28 x1 x2 x7 x4 x5 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_2 x10 x6 x9 x7 x2 x1 (Curry_Prelude.d_C_otherwise cd
    cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x4 x6 x10 x9
    x7 x2 x1 x5 l s cd cs) (nd_C__case_3 x4 x6 x10 x9 x7 x2 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x4
    x6 x10 x9 x7 x2 x1 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_3 x4 x6 x10 x9
    x7 x2 x1 x5 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.SCC._case_3"
    [show x4, show x6, show x10, show x9, show x7, show x2, show x1, show x5
    , show x11] info)
  _ -> failCons cd (consFail "Data.SCC._case_3" (showCons x11))

d_C__case_2 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (C_Node t0 t1) -> C_Node t0 t1
  -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1) -> Curry_Prelude.OP_List
  (C_Node t0 t1) -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1
  -> Curry_Prelude.OP_List (C_Node t0 t1) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_RedBlackTree.C_RedBlackTree
  (C_Node t0 t1)) (Curry_Prelude.OP_List (C_Node t0 t1))
d_C__case_2 x10 x6 x9 x7 x2 x1 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_OP_tsort_dot_dfs_dot_28 x1 x2 x7 x9
    (Curry_Prelude.OP_Cons x6 x10) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x10 x6 x9 x7 x2
    x1 l cd cs) (d_C__case_2 x10 x6 x9 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x10
    x6 x9 x7 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_2 x10 x6 x9 x7 x2
    x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.SCC._case_2"
    [show x10, show x6, show x9, show x7, show x2, show x1, show x11] info)
  _ -> failCons cd (consFail "Data.SCC._case_2" (showCons x11))

nd_C__case_2 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (C_Node t0 t1) -> C_Node t0 t1
  -> Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1) -> Curry_Prelude.OP_List
  (C_Node t0 t1) -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1
  -> Curry_Prelude.OP_List (C_Node t0 t1) -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_RedBlackTree.C_RedBlackTree (C_Node t0 t1)) (Curry_Prelude.OP_List
  (C_Node t0 t1))
nd_C__case_2 x10 x6 x9 x7 x2 x1 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_OP_tsort_dot_dfs_dot_28 x1 x2 x7 x9 (Curry_Prelude.OP_Cons x6
    x10) s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x10 x6 x9 x7
    x2 x1 l s cd cs) (nd_C__case_2 x10 x6 x9 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x10
    x6 x9 x7 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_2 x10 x6 x9 x7
    x2 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.SCC._case_2"
    [show x10, show x6, show x9, show x7, show x2, show x1, show x11] info)
  _ -> failCons cd (consFail "Data.SCC._case_2" (showCons x11))

d_C__case_4 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List
  t1 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List t1
  -> Curry_Prelude.C_Int -> C_Node t0 t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_4 x8 x1 x7 x2 x6 x5 x4 cd cs = case x4 of
  C_Node x9 x10 x11 x12 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
    x5 x9 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    x2 x6 x10 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    x2 x7 x11 cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_eq_eq x1 cd cs) x8 cd cs) x12 cd cs) cd cs
  Choice_C_Node d i l r -> narrow d i (d_C__case_4 x8 x1 x7 x2 x6 x5 l cd cs)
    (d_C__case_4 x8 x1 x7 x2 x6 x5 r cd cs)
  Choices_C_Node d i xs -> narrows cs d i (\z -> d_C__case_4 x8 x1 x7 x2 x6 x5 z
    cd cs) xs
  Guard_C_Node d c e -> guardCons d c (d_C__case_4 x8 x1 x7 x2 x6 x5 e cd $!
    addCs c cs)
  Fail_C_Node d info -> failCons d (traceFail "Data.SCC._case_4" [show x8, show
    x1, show x7, show x2, show x6, show x5, show x4] info)
  _ -> failCons cd (consFail "Data.SCC._case_4" (showCons x4))

nd_C__case_4 :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t0 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_List
  t1 -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1 -> Curry_Prelude.OP_List t1
  -> Curry_Prelude.C_Int -> C_Node t0 t1 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C__case_4 x8 x1 x7 x2 x6 x5 x4 s cd cs = case x4 of
  C_Node x9 x10 x11 x12 -> let s8 = s
    in s8 `seq` (let s2 = leftSupply s8
                     s7 = rightSupply s8
    in s2 `seq` (s7 `seq` Curry_Prelude.d_OP_amp_amp (let s0 = leftSupply s2
                                                          s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
    x5 x9 cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    x2 x6 x10 s0 cd cs) cd cs)
    (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    x2 x7 x11 s1 cd cs) cd cs)) (let s6 = leftSupply s7
                                     s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq x1
    s3 cd cs) x8 s4 cd cs)) x12 s6 cd cs)) cd cs))
  Choice_C_Node d i l r -> narrow d i (nd_C__case_4 x8 x1 x7 x2 x6 x5 l s cd cs)
    (nd_C__case_4 x8 x1 x7 x2 x6 x5 r s cd cs)
  Choices_C_Node d i xs -> narrows cs d i (\z -> nd_C__case_4 x8 x1 x7 x2 x6 x5
    z s cd cs) xs
  Guard_C_Node d c e -> guardCons d c (nd_C__case_4 x8 x1 x7 x2 x6 x5 e s cd $!
    addCs c cs)
  Fail_C_Node d info -> failCons d (traceFail "Data.SCC._case_4" [show x8, show
    x1, show x7, show x2, show x6, show x5, show x4] info)
  _ -> failCons cd (consFail "Data.SCC._case_4" (showCons x4))

