{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE Rank2Types #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Curry_EliminateCond ( d_C_eliminateCond ) where

import Basics
import qualified FlatCurry.Annotated.Curry_Goodies
import qualified FlatCurry.Annotated.Curry_Types
import qualified FlatCurry.Curry_Types
import qualified Curry_List
import qualified Curry_Prelude
import qualified Curry_State


d_C_eliminateCond :: FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr
d_C_eliminateCond x1 cd cs = Curry_Prelude.d_C_apply
  (FlatCurry.Annotated.Curry_Goodies.d_C_updProgFuncs
  (Curry_Prelude.d_C_concatMap d_C_transFunc cd cs) cd cs) x1 cd cs

d_C_transFunc :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_transFunc x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x6 -> d_C__case_31 x2 x5
    x4 x3 x1 x6 cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_C_transFunc l cd cs) (d_C_transFunc r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> d_C_transFunc z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_C_transFunc e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "EliminateCond.transFunc" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.transFunc" (showCons x1))

d_OP_transFunc_dot_uscore_hash_selFP2_hash_e_tick :: Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
d_OP_transFunc_dot_uscore_hash_selFP2_hash_e_tick x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_30 x2 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_transFunc_dot_uscore_hash_selFP2_hash_e_tick l cd cs)
    (d_OP_transFunc_dot_uscore_hash_selFP2_hash_e_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_transFunc_dot_uscore_hash_selFP2_hash_e_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_transFunc_dot_uscore_hash_selFP2_hash_e_tick e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.transFunc._#selFP2#e'" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.transFunc._#selFP2#e'" (showCons
    x1))

d_OP_transFunc_dot_uscore_hash_selFP3_hash_newFuns :: Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_transFunc_dot_uscore_hash_selFP3_hash_newFuns x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_29 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_transFunc_dot_uscore_hash_selFP3_hash_newFuns l cd cs)
    (d_OP_transFunc_dot_uscore_hash_selFP3_hash_newFuns r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_transFunc_dot_uscore_hash_selFP3_hash_newFuns z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_transFunc_dot_uscore_hash_selFP3_hash_newFuns e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.transFunc._#selFP3#newFuns" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.transFunc._#selFP3#newFuns"
    (showCons x1))

d_C_transExpr :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C_transExpr x1 x2 cd cs = FlatCurry.Annotated.Curry_Goodies.d_C_trExpr
  (acceptCs id d_OP_transExpr_dot_transVar_dot_17) (acceptCs id
  d_OP_transExpr_dot_transLit_dot_17) (acceptCs (acceptCs (acceptCs id))
  (d_OP_transExpr_dot_transComb_dot_17 x1)) (acceptCs (acceptCs id)
  d_OP_transExpr_dot_transLet_dot_17) (acceptCs (acceptCs id)
  d_OP_transExpr_dot_transFree_dot_17) (acceptCs (acceptCs id)
  d_OP_transExpr_dot_transOr_dot_17) (acceptCs (acceptCs (acceptCs id))
  d_OP_transExpr_dot_transCase_dot_17) (acceptCs id
  d_OP_transExpr_dot_transBranch_dot_17) (acceptCs (acceptCs id)
  d_OP_transExpr_dot_transTyped_dot_17) x2 cd cs

d_OP_transExpr_dot_transVar_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transVar_dot_17 x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (acceptCs id Curry_State.d_C_returnS) (FlatCurry.Annotated.Curry_Types.C_AVar
  x1 x2) cd cs

d_OP_transExpr_dot_transLit_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> FlatCurry.Curry_Types.C_Literal -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transLit_dot_17 x1 x2 cd cs = Curry_Prelude.d_OP_dollar
  (acceptCs id Curry_State.d_C_returnS) (FlatCurry.Annotated.Curry_Types.C_ALit
  x1 x2) cd cs

d_OP_transExpr_dot_transComb_dot_17 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 x4 x5 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> d_C__case_28 x5 x6 x2 x7 x3 x1
    (Curry_Prelude.OP_Tuple2 x6 x5) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 l x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 r x5 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 z x5 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 e x5 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.transExpr.transComb.17" [show x1, show x2, show x3, show x4
    , show x5] info)
  _ -> failCons cd (consFail "EliminateCond.transExpr.transComb.17" (showCons
    x4))

nd_OP_transExpr_dot_transComb_dot_17 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 x4 x5 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_28 x5 x6 x2 x7 x3 x1 (Curry_Prelude.OP_Tuple2 x6 x5)
    s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 l x5 s cd cs)
    (nd_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 r x5 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 z x5 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_transExpr_dot_transComb_dot_17 x1 x2 x3 e x5 s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.transExpr.transComb.17" [show x1, show x2, show x3, show x4
    , show x5] info)
  _ -> failCons cd (consFail "EliminateCond.transExpr.transComb.17" (showCons
    x4))

d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2 x1 x2 x3 x4 cd cs =
  Curry_State.d_C_bindS x3
  (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3
  x1 x4 x2)

nd_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2 x1 x2 x3 x4 s cd cs =
  wrapNX id (Curry_State.nd_C_bindS x3 (wrapDX (wrapDX id)
  (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3
  x1 x4 x2)))

d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2_dot_uscore_hash_lambda3 x1 x2 x3 x4 cd cs =
  d_C_makeAuxFuncCall x3 x1 x2 x4 cd cs

d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 :: FlatCurry.Curry_Types.C_CombType
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x1 x2 x3 x4 x5 cd cs =
  Curry_State.d_C_returnS (FlatCurry.Annotated.Curry_Types.C_AComb x3 x1
  (Curry_Prelude.OP_Tuple2 x4 x2) x5)

d_OP_transExpr_dot_transLet_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) (t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)) -> (t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transLet_dot_17 x1 x2 x3 cd cs =
  let x4 = Curry_Prelude.d_C_unzip x2 cd cs
      x5 = d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars
        x4 cd cs
      x6 = d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps
        x4 cd cs
  in Curry_State.d_C_bindS (Curry_Prelude.d_C_apply (Curry_State.d_C_sequenceS
  cd cs) x6 cd cs) (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5
  x1 x5 x3)

nd_OP_transExpr_dot_transLet_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  (Func t1 (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0)
  t1))) -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> IDSupply -> Cover
  -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_transExpr_dot_transLet_dot_17 x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s0 = leftSupply s5
                   s6 = rightSupply s5
                   s1 = leftSupply s6
                   s4 = rightSupply s6
  in s0 `seq` (s6 `seq` (s1 `seq` (s4 `seq` (let x4 = Curry_Prelude.d_C_unzip x2
                                                   cd cs
                                                 x5 = nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars
                                                   x4 s0 cd cs
                                                 x6 = nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps
                                                   x4 s1 cd cs
  in wrapNX id (Curry_State.nd_C_bindS (let s3 = leftSupply s4
                                            s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS s2
  cd cs) x6 s3 cd cs)) (wrapNX id
  (nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5 x1 x5 x3))))))))

d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars :: forall t1
  t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)) (Curry_Prelude.OP_List (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)
d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars l cd
    cs) (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.transExpr.transLet.17._#selFP5#vars" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.transExpr.transLet.17._#selFP5#vars"
    (showCons x1))

nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars :: forall t1
  t0 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)) (Curry_Prelude.OP_List (Func t1
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars l s cd
    cs) (nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars r
    s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP5_hash_vars e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.transExpr.transLet.17._#selFP5#vars" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.transExpr.transLet.17._#selFP5#vars"
    (showCons x1))

d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)) (Curry_Prelude.OP_List (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps l cd
    cs) (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.transExpr.transLet.17._#selFP6#exps" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.transExpr.transLet.17._#selFP6#exps"
    (showCons x1))

nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0)) (Curry_Prelude.OP_List (Func t1
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)))
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List (Func t1
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1))
nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps x1 s cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps l s cd
    cs) (nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps r
    s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_selFP6_hash_exps e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.transExpr.transLet.17._#selFP6#exps" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.transExpr.transLet.17._#selFP6#exps"
    (showCons x1))

d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5 x1 x2 x3 x4 cd cs =
  Curry_State.d_C_bindS x3
  (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6
  x1 x4 x2)

nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> Func t1 (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  t0) t1) -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AExpr t0)
  -> IDSupply -> Cover -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5 x1 x2 x3 x4 s cd cs =
  wrapNX id (Curry_State.nd_C_bindS x3 (wrapDX (wrapDX id)
  (d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6
  x1 x4 x2)))

d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AExpr t0)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transLet_dot_17_dot_uscore_hash_lambda5_dot_uscore_hash_lambda6 x1 x2 x3 x4 cd cs =
  Curry_State.d_C_returnS (FlatCurry.Annotated.Curry_Types.C_ALet x1
  (Curry_Prelude.d_C_zip x3 x2 cd cs) x4)

d_OP_transExpr_dot_transFree_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transFree_dot_17 x1 x2 x3 cd cs = Curry_State.d_C_bindS x3
  (d_OP_transExpr_dot_transFree_dot_17_dot_uscore_hash_lambda7 x1 x2)

nd_OP_transExpr_dot_transFree_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Func t1
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> IDSupply -> Cover -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_transExpr_dot_transFree_dot_17 x1 x2 x3 s cd cs = wrapNX id
  (Curry_State.nd_C_bindS x3 (wrapDX (wrapDX id)
  (d_OP_transExpr_dot_transFree_dot_17_dot_uscore_hash_lambda7 x1 x2)))

d_OP_transExpr_dot_transFree_dot_17_dot_uscore_hash_lambda7 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transFree_dot_17_dot_uscore_hash_lambda7 x1 x2 x3 cd cs =
  Curry_State.d_C_returnS (FlatCurry.Annotated.Curry_Types.C_AFree x1 x2 x3)

d_OP_transExpr_dot_transOr_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transOr_dot_17 x1 x2 x3 cd cs = Curry_State.d_C_bindS x2
  (d_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8 x1 x3)

nd_OP_transExpr_dot_transOr_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> Func t1
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> IDSupply -> Cover -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_transExpr_dot_transOr_dot_17 x1 x2 x3 s cd cs = wrapNX id
  (Curry_State.nd_C_bindS x2 (wrapNX id
  (nd_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8 x1 x3)))

d_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0 -> (t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8 x1 x2 x3 cd cs =
  Curry_State.d_C_bindS x2
  (d_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9
  x1 x3)

nd_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0 -> Func t1
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> IDSupply -> Cover
  -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8 x1 x2 x3 s cd cs =
  wrapNX id (Curry_State.nd_C_bindS x2 (wrapDX (wrapDX id)
  (d_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9
  x1 x3)))

d_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transOr_dot_17_dot_uscore_hash_lambda8_dot_uscore_hash_lambda9 x1 x2 x3 cd cs =
  Curry_State.d_C_returnS (FlatCurry.Annotated.Curry_Types.C_AOr x1 x2 x3)

d_OP_transExpr_dot_transCase_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> FlatCurry.Curry_Types.C_CaseType -> (t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> Curry_Prelude.OP_List (t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1) -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transCase_dot_17 x1 x2 x3 x4 cd cs = Curry_State.d_C_bindS x3
  (d_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10 x2 x1 x4)

nd_OP_transExpr_dot_transCase_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> FlatCurry.Curry_Types.C_CaseType -> Func t1
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> Curry_Prelude.OP_List (Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1)) -> IDSupply -> Cover
  -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_transExpr_dot_transCase_dot_17 x1 x2 x3 x4 s cd cs = wrapNX id
  (Curry_State.nd_C_bindS x3 (wrapNX id
  (nd_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10 x2 x1 x4)))

d_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => FlatCurry.Curry_Types.C_CaseType -> t0 -> Curry_Prelude.OP_List (t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10 x1 x2 x3 x4 cd cs =
  Curry_State.d_C_bindS (Curry_Prelude.d_C_apply (Curry_State.d_C_sequenceS cd
  cs) x3 cd cs)
  (d_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11
  x1 x2 x4)

nd_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => FlatCurry.Curry_Types.C_CaseType -> t0 -> Curry_Prelude.OP_List (Func
  t1 (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0)
  t1)) -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> IDSupply -> Cover
  -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10 x1 x2 x3 x4 s cd cs =
  let s2 = s
  in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                     s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS s0
  cd cs) x3 s1 cd cs)) (wrapDX (wrapDX id)
  (d_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11
  x1 x2 x4)))

d_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => FlatCurry.Curry_Types.C_CaseType -> t0
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transCase_dot_17_dot_uscore_hash_lambda10_dot_uscore_hash_lambda11 x1 x2 x3 x4 cd cs =
  Curry_State.d_C_returnS (FlatCurry.Annotated.Curry_Types.C_ACase x2 x1 x3 x4)

d_OP_transExpr_dot_transBranch_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => FlatCurry.Annotated.Curry_Types.C_APattern t0
  -> (t1 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1
d_OP_transExpr_dot_transBranch_dot_17 x1 x2 cd cs = Curry_State.d_C_bindS x2
  (d_OP_transExpr_dot_transBranch_dot_17_dot_uscore_hash_lambda12 x1)

nd_OP_transExpr_dot_transBranch_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => FlatCurry.Annotated.Curry_Types.C_APattern t0
  -> Func t1 (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  t0) t1) -> IDSupply -> Cover -> ConstStore -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1)
nd_OP_transExpr_dot_transBranch_dot_17 x1 x2 s cd cs = wrapNX id
  (Curry_State.nd_C_bindS x2 (wrapDX (wrapDX id)
  (d_OP_transExpr_dot_transBranch_dot_17_dot_uscore_hash_lambda12 x1)))

d_OP_transExpr_dot_transBranch_dot_17_dot_uscore_hash_lambda12 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_APattern t0
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0) t1
d_OP_transExpr_dot_transBranch_dot_17_dot_uscore_hash_lambda12 x1 x2 cd cs =
  Curry_State.d_C_returnS (FlatCurry.Annotated.Curry_Types.C_ABranch x1 x2)

d_OP_transExpr_dot_transTyped_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> (t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transTyped_dot_17 x1 x2 x3 cd cs = Curry_State.d_C_bindS x2
  (d_OP_transExpr_dot_transTyped_dot_17_dot_uscore_hash_lambda13 x3 x1)

nd_OP_transExpr_dot_transTyped_dot_17 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Func t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  t1 (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1)
nd_OP_transExpr_dot_transTyped_dot_17 x1 x2 x3 s cd cs = wrapNX id
  (Curry_State.nd_C_bindS x2 (wrapDX (wrapDX id)
  (d_OP_transExpr_dot_transTyped_dot_17_dot_uscore_hash_lambda13 x3 x1)))

d_OP_transExpr_dot_transTyped_dot_17_dot_uscore_hash_lambda13 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => FlatCurry.Curry_Types.C_TypeExpr -> t0
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr t0) t1
d_OP_transExpr_dot_transTyped_dot_17_dot_uscore_hash_lambda13 x1 x2 x3 cd cs =
  Curry_State.d_C_returnS (FlatCurry.Annotated.Curry_Types.C_ATyped x2 x3 x1)

d_C_makeAuxFuncCall :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C_makeAuxFuncCall x1 x2 x3 x4 cd cs =
  let x5 = FlatCurry.Annotated.Curry_Goodies.d_C_annExpr x3 cd cs
      x6 = d_C_unboundVars x4 cd cs
      x7 = Curry_Prelude.d_C_zip (Curry_Prelude.d_C_apply
        (Curry_Prelude.d_OP_uscore_impl_hash_enumFrom_hash_Prelude_dot_Enum_hash_Prelude_dot_Int
        cd cs) (Curry_Prelude.C_Int (1)) cd cs) (Curry_Prelude.d_OP_plus_plus
        (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x6 cd cs)
        (Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List) cd cs) cd cs
      x8 = Curry_Prelude.d_C_foldr (acceptCs (acceptCs id)
        FlatCurry.Curry_Types.C_FuncType) x2 (Curry_Prelude.d_C_map
        Curry_Prelude.d_C_snd x7 cd cs) cd cs
      x9 = Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int
        (Curry_Prelude.d_C_length x6 cd cs) (Curry_Prelude.C_Int (1)) cd cs
      x10 = FlatCurry.Annotated.Curry_Types.C_ARule x8 x7
        (FlatCurry.Annotated.Curry_Types.C_ACase x2 FlatCurry.Curry_Types.C_Flex
        (FlatCurry.Annotated.Curry_Types.C_AVar x5 x9) (Curry_Prelude.OP_Cons
        (FlatCurry.Annotated.Curry_Types.C_ABranch
        (FlatCurry.Annotated.Curry_Types.C_APattern x5 (Curry_Prelude.OP_Tuple2
        (d_C_trueId cd cs) (d_C_boolType cd cs)) Curry_Prelude.OP_List)
        (Curry_Prelude.d_C_apply
        (FlatCurry.Annotated.Curry_Goodies.d_C_rnmAllVars
        (d_OP_makeAuxFuncCall_dot_renameVarFun_dot_56 x6) cd cs) x4 cd cs))
        Curry_Prelude.OP_List))
  in Curry_State.d_C_bindS Curry_State.d_C_getS
  (d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14 x8 x2 x9 x6 x3 x10 x1)

d_OP_makeAuxFuncCall_dot_renameVarFun_dot_56 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_OP_makeAuxFuncCall_dot_renameVarFun_dot_56 x1 x2 cd cs =
  Curry_Prelude.d_C_maybe x2 (Curry_Prelude.d_C_flip (acceptCs id
  Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int)
  (Curry_Prelude.C_Int (1))) (Curry_Prelude.d_C_apply (Curry_List.d_C_elemIndex
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
  cs) x2 cd cs) (Curry_Prelude.d_C_map Curry_Prelude.d_C_fst x1 cd cs) cd cs) cd
  cs

d_OP_makeAuxFuncCall_dot_mkNewName_dot_56 :: forall t0 t1 . (Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_uscore_Dict_hash_Show t0
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Tuple2 x4
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "__cond_")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_show x1 cd cs) x3 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "_") x5 cd cs) cd cs) cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 l x3 cd cs)
    (d_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 z x3 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 e x3 cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.makeAuxFuncCall.mkNewName.56" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "EliminateCond.makeAuxFuncCall.mkNewName.56"
    (showCons x2))

nd_OP_makeAuxFuncCall_dot_mkNewName_dot_56 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_uscore_Dict_hash_Show t0 -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` Curry_Prelude.OP_Tuple2 x4 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "__cond_") (Curry_Prelude.d_OP_plus_plus
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_show x1
    s0 cd cs) x3 s1 cd cs)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "_") x5 cd cs) cd cs) cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 l x3 s cd cs)
    (nd_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x1 e x3 s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.makeAuxFuncCall.mkNewName.56" [show x1, show x2, show x3]
    info)
  _ -> failCons cd (consFail "EliminateCond.makeAuxFuncCall.mkNewName.56"
    (showCons x2))

d_OP_makeAuxFuncCall_dot_newFun_dot_56 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0 -> t0 -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr
d_OP_makeAuxFuncCall_dot_newFun_dot_56 x1 x2 x3 x4 x5 x6 cd cs =
  FlatCurry.Annotated.Curry_Types.C_AFunc
  (d_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x5 x4 x6 cd cs) x2
  FlatCurry.Curry_Types.C_Private x1 x3

nd_OP_makeAuxFuncCall_dot_newFun_dot_56 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t0 -> t0 -> IDSupply -> Cover
  -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr
nd_OP_makeAuxFuncCall_dot_newFun_dot_56 x1 x2 x3 x4 x5 x6 s cd cs = let s0 = s
  in s0 `seq` FlatCurry.Annotated.Curry_Types.C_AFunc
  (nd_OP_makeAuxFuncCall_dot_mkNewName_dot_56 x5 x4 x6 s0 cd cs) x2
  FlatCurry.Curry_Types.C_Private x1 x3

d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 x7 x8 cd cs =
  case x8 of
  Curry_Prelude.OP_Tuple2 x9 x10 -> Curry_State.d_C_bindS (Curry_State.d_C_putS
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons
    (d_OP_makeAuxFuncCall_dot_newFun_dot_56 x1 x3 x6 x7
    (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int
    cd cs) x10 cd cs) x9)
    (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    x10 (Curry_Prelude.C_Int (1)) cd cs)))
    (d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1
    x2 x10 x4 x5 x7)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 x7 l cd cs)
    (d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 x7 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 x7 z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14 x1 x2 x3 x4 x5 x6 x7 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.makeAuxFuncCall._#lambda14" [show x1, show x2, show x3, show
    x4, show x5, show x6, show x7, show x8] info)
  _ -> failCons cd (consFail "EliminateCond.makeAuxFuncCall._#lambda14"
    (showCons x8))

d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_OP_makeAuxFuncCall_dot_uscore_hash_lambda14_dot_uscore_hash_lambda15 x1 x2 x3 x4 x5 x6 x7 cd cs =
  Curry_Prelude.d_OP_dollar (acceptCs id Curry_State.d_C_returnS)
  (FlatCurry.Annotated.Curry_Types.C_AComb x2 FlatCurry.Curry_Types.C_FuncCall
  (Curry_Prelude.OP_Tuple2 (d_OP_makeAuxFuncCall_dot_mkNewName_dot_56
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Prelude_dot_Int cd
  cs) x6 x3 cd cs) x1) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map
  (Curry_Prelude.d_C_uncurry (acceptCs id (Curry_Prelude.d_C_flip (acceptCs
  (acceptCs id) FlatCurry.Annotated.Curry_Types.C_AVar)))) x4 cd cs)
  (Curry_Prelude.OP_Cons x5 Curry_Prelude.OP_List) cd cs)) cd cs

d_C_boolType :: Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr
d_C_boolType cd cs = FlatCurry.Curry_Types.C_TCons (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.toCurryString "Prelude") (Curry_Prelude.toCurryString "Bool"))
  Curry_Prelude.OP_List

d_C_trueId :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_C_trueId cd cs = Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString
  "Prelude") (Curry_Prelude.toCurryString "True")

d_C_unboundVars :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_unboundVars x1 cd cs = Curry_List.d_C_nub
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
  cs)
  (FlatCurry.Curry_Types.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_FlatCurry_dot_Types_dot_TypeExpr
  cd cs) cd cs) (FlatCurry.Annotated.Curry_Goodies.d_C_trExpr (acceptCs id
  d_OP_unboundVars_dot_var_dot_77) (acceptCs id d_OP_unboundVars_dot_lit_dot_77)
  (acceptCs (acceptCs id) d_OP_unboundVars_dot_comb_dot_77) (acceptCs (acceptCs
  id) (d_OP_unboundVars_dot_leT_dot_77
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
  cs))) (acceptCs id (d_OP_unboundVars_dot_freE_dot_77
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
  cs))) d_OP_unboundVars_dot_oR_dot_77 (acceptCs (acceptCs (acceptCs id))
  d_OP_unboundVars_dot_casE_dot_77) (acceptCs id
  d_OP_unboundVars_dot_branch_dot_77) (acceptCs (acceptCs id)
  d_OP_unboundVars_dot_typed_dot_77) x1 cd cs) cd cs

d_OP_unboundVars_dot_var_dot_77 :: forall t1 t0 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
d_OP_unboundVars_dot_var_dot_77 x1 x2 cd cs = Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 x2 x1) Curry_Prelude.OP_List

d_OP_unboundVars_dot_lit_dot_77 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0 -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t2
d_OP_unboundVars_dot_lit_dot_77 x1 x2 cd cs = Curry_Prelude.OP_List

d_OP_unboundVars_dot_comb_dot_77 :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t0 -> t1 -> t2 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List t3) -> Cover -> ConstStore -> Curry_Prelude.OP_List t3
d_OP_unboundVars_dot_comb_dot_77 x1 x2 x3 cd cs = Curry_Prelude.d_C_concat

d_OP_unboundVars_dot_leT_dot_77 :: forall t1 t2 t0 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t1 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 t2)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3)))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3)
d_OP_unboundVars_dot_leT_dot_77 x1 x2 x3 x4 cd cs =
  let x5 = Curry_Prelude.d_C_unzip x3 cd cs
      x6 = d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP8_hash_vs x5 cd
        cs
      x7 = d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP9_hash_es x5 cd
        cs
  in Curry_Prelude.d_C_filter
  (d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_lambda16 x6 x1)
  (Curry_Prelude.d_C_concat (Curry_Prelude.OP_Cons x4 x7) cd cs) cd cs

nd_OP_unboundVars_dot_leT_dot_77 :: forall t1 t2 t0 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t1 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 t2)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3)))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3)
nd_OP_unboundVars_dot_leT_dot_77 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` (let x5 = Curry_Prelude.d_C_unzip x3 cd cs
                   x6 = d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP8_hash_vs
                     x5 cd cs
                   x7 = d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP9_hash_es
                     x5 cd cs
  in Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_lambda16 x6 x1))
  (Curry_Prelude.d_C_concat (Curry_Prelude.OP_Cons x4 x7) cd cs) s0 cd cs)

d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP8_hash_vs :: forall t2 t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t2) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t0 t1)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t0 t2))) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 t1)
d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP8_hash_vs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP8_hash_vs l cd cs)
    (d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP8_hash_vs r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP8_hash_vs z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP8_hash_vs e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.unboundVars.leT.77._#selFP8#vs" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.unboundVars.leT.77._#selFP8#vs"
    (showCons x1))

d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP9_hash_es :: forall t1 t0
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t0 t1)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  t0 t2))) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t2))
d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP9_hash_es x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP9_hash_es l cd cs)
    (d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP9_hash_es r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP9_hash_es z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_selFP9_hash_es e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond.unboundVars.leT.77._#selFP9#es" [show x1] info)
  _ -> failCons cd (consFail "EliminateCond.unboundVars.leT.77._#selFP9#es"
    (showCons x1))

d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_lambda16 :: forall t1 t0
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_Tuple2 t0 t2
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_lambda16 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_notElem x2 (Curry_Prelude.d_C_fst
  x3 cd cs) cd cs) (Curry_Prelude.d_C_map Curry_Prelude.d_C_fst x1 cd cs) cd cs

nd_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_lambda16 :: forall t1 t0
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_Tuple2 t0 t2
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_unboundVars_dot_leT_dot_77_dot_uscore_hash_lambda16 x1 x2 x3 s cd cs =
  let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_C_notElem x2 (Curry_Prelude.d_C_fst x3 cd cs) s0 cd cs)
  (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_fst) x1 s1 cd cs) s2 cd
  cs))))

d_OP_unboundVars_dot_freE_dot_77 :: forall t1 t2 t0 t3 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t1 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 t2) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3)
d_OP_unboundVars_dot_freE_dot_77 x1 x2 x3 cd cs = Curry_Prelude.d_C_filter
  (d_OP_unboundVars_dot_freE_dot_77_dot_uscore_hash_lambda17 x3 x1)

nd_OP_unboundVars_dot_freE_dot_77 :: forall t1 t2 t0 t3 . (Curry_Prelude.Curry
  t3, Curry_Prelude.Curry t0, Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> t1 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 t2) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t3)) (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 t3))
nd_OP_unboundVars_dot_freE_dot_77 x1 x2 x3 s cd cs = wrapNX id
  (Curry_Prelude.nd_C_filter (wrapNX id
  (nd_OP_unboundVars_dot_freE_dot_77_dot_uscore_hash_lambda17 x3 x1)))

d_OP_unboundVars_dot_freE_dot_77_dot_uscore_hash_lambda17 :: forall t1 t0
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_Tuple2 t0 t2
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_unboundVars_dot_freE_dot_77_dot_uscore_hash_lambda17 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_notElem x2 (Curry_Prelude.d_C_fst
  x3 cd cs) cd cs) (Curry_Prelude.d_C_map Curry_Prelude.d_C_fst x1 cd cs) cd cs

nd_OP_unboundVars_dot_freE_dot_77_dot_uscore_hash_lambda17 :: forall t1 t0
  t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t1)
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0 -> Curry_Prelude.OP_Tuple2 t0 t2
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_unboundVars_dot_freE_dot_77_dot_uscore_hash_lambda17 x1 x2 x3 s cd cs =
  let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
  (Curry_Prelude.nd_C_notElem x2 (Curry_Prelude.d_C_fst x3 cd cs) s0 cd cs)
  (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_fst) x1 s1 cd cs) s2 cd
  cs))))

d_OP_unboundVars_dot_oR_dot_77 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_OP_unboundVars_dot_oR_dot_77 x1 cd cs = acceptCs id
  Curry_Prelude.d_OP_plus_plus

d_OP_unboundVars_dot_casE_dot_77 :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t0 -> t1
  -> Curry_Prelude.OP_List t2 -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  t2) -> Cover -> ConstStore -> Curry_Prelude.OP_List t2
d_OP_unboundVars_dot_casE_dot_77 x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_concat
  (Curry_Prelude.OP_Cons x3 x4) cd cs

d_OP_unboundVars_dot_branch_dot_77 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => FlatCurry.Annotated.Curry_Types.C_APattern t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t1)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1)
d_OP_unboundVars_dot_branch_dot_77 x1 x2 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_APattern x3 x4 x5 -> Curry_Prelude.d_C_filter
    (d_OP_unboundVars_dot_branch_dot_77_dot_uscore_hash_lambda19 x5) x2 cd cs
  FlatCurry.Annotated.Curry_Types.C_ALPattern x6 x7 -> Curry_Prelude.d_C_error
    (Curry_Prelude.toCurryString "EliminateCond.unboundVars") cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_APattern d i l r -> narrow d i
    (d_OP_unboundVars_dot_branch_dot_77 l x2 cd cs)
    (d_OP_unboundVars_dot_branch_dot_77 r x2 cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_APattern d i xs -> narrows cs d i
    (\z -> d_OP_unboundVars_dot_branch_dot_77 z x2 cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_APattern d c e -> guardCons d c
    (d_OP_unboundVars_dot_branch_dot_77 e x2 cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_APattern d info -> failCons d
    (traceFail "EliminateCond.unboundVars.branch.77" [show x1, show x2] info)
  _ -> failCons cd (consFail "EliminateCond.unboundVars.branch.77" (showCons
    x1))

d_OP_unboundVars_dot_branch_dot_77_dot_uscore_hash_lambda19 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t1 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_unboundVars_dot_branch_dot_77_dot_uscore_hash_lambda19 x1 x2 cd cs =
  Curry_Prelude.d_C_apply (Curry_Prelude.d_C_notElem
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Int cd
  cs) (Curry_Prelude.d_C_fst x2 cd cs) cd cs) (Curry_Prelude.d_C_map
  Curry_Prelude.d_C_fst x1 cd cs) cd cs

d_OP_unboundVars_dot_typed_dot_77 :: forall t0 t2 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => t0 -> t1 -> t2 -> Cover
  -> ConstStore -> t1
d_OP_unboundVars_dot_typed_dot_77 x1 x2 x3 cd cs = x2

d_C__case_28 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_28 x5 x6 x2 x7 x3 x1 x10 cd cs = case x10 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> d_C__case_27 x6 x2 x7 x3 x5 x9 x1 x8 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_28 x5 x6 x2 x7
    x3 x1 l cd cs) (d_C__case_28 x5 x6 x2 x7 x3 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_28
    x5 x6 x2 x7 x3 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_28 x5 x6 x2 x7
    x3 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond._case_28" [show x5, show x6, show x2, show x7, show x3, show
    x1, show x10] info)
  _ -> failCons cd (consFail "EliminateCond._case_28" (showCons x10))

nd_C__case_28 :: Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_28 x5 x6 x2 x7 x3 x1 x10 s cd cs = case x10 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_27 x6 x2 x7 x3 x5 x9 x1 x8 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_28 x5 x6 x2
    x7 x3 x1 l s cd cs) (nd_C__case_28 x5 x6 x2 x7 x3 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_28
    x5 x6 x2 x7 x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_28 x5 x6 x2
    x7 x3 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond._case_28" [show x5, show x6, show x2, show x7, show x3, show
    x1, show x10] info)
  _ -> failCons cd (consFail "EliminateCond._case_28" (showCons x10))

d_C__case_27 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_27 x6 x2 x7 x3 x5 x9 x1 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> d_C__case_26 x6 x2 x7 x3 x5 x11 x9 x1 x10
    cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_27 x6 x2 x7 x3
    x5 x9 x1 l cd cs) (d_C__case_27 x6 x2 x7 x3 x5 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_27
    x6 x2 x7 x3 x5 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_27 x6 x2 x7 x3
    x5 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond._case_27" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x8] info)
  _ -> failCons cd (consFail "EliminateCond._case_27" (showCons x8))

nd_C__case_27 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_27 x6 x2 x7 x3 x5 x9 x1 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> let s0 = s
    in s0 `seq` nd_C__case_26 x6 x2 x7 x3 x5 x11 x9 x1 x10 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_27 x6 x2 x7
    x3 x5 x9 x1 l s cd cs) (nd_C__case_27 x6 x2 x7 x3 x5 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_27
    x6 x2 x7 x3 x5 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_27 x6 x2 x7
    x3 x5 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond._case_27" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x8] info)
  _ -> failCons cd (consFail "EliminateCond._case_27" (showCons x8))

d_C__case_26 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_26 x6 x2 x7 x3 x5 x11 x9 x1 x10 cd cs = case x10 of
  Curry_Prelude.OP_Cons x12 x13 -> d_C__case_25 x12 x6 x2 x7 x3 x5 x13 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x12 (Curry_Prelude.C_Char 'P'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_26 x6 x2 x7 x3
    x5 x11 x9 x1 l cd cs) (d_C__case_26 x6 x2 x7 x3 x5 x11 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_26 x6
    x2 x7 x3 x5 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_26 x6 x2 x7 x3
    x5 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_26" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x10] info)
  _ -> failCons cd (consFail "EliminateCond._case_26" (showCons x10))

nd_C__case_26 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_26 x6 x2 x7 x3 x5 x11 x9 x1 x10 s cd cs = case x10 of
  Curry_Prelude.OP_Cons x12 x13 -> let s0 = s
    in s0 `seq` nd_C__case_25 x12 x6 x2 x7 x3 x5 x13 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x12 (Curry_Prelude.C_Char 'P'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_26 x6 x2 x7 x3
    x5 x11 x9 x1 l s cd cs) (nd_C__case_26 x6 x2 x7 x3 x5 x11 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_26 x6
    x2 x7 x3 x5 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_26 x6 x2 x7 x3
    x5 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_26" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x10] info)
  _ -> failCons cd (consFail "EliminateCond._case_26" (showCons x10))

d_C__case_25 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_25 x12 x6 x2 x7 x3 x5 x13 x11 x9 x1 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> d_C__case_24 x6 x2 x7 x3 x5 x11 x9 x1 x13 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x12 x6 x2 x7
    x3 x5 x13 x11 x9 x1 l cd cs) (d_C__case_25 x12 x6 x2 x7 x3 x5 x13 x11 x9 x1
    r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x12
    x6 x2 x7 x3 x5 x13 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_25 x12 x6 x2 x7
    x3 x5 x13 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_25" [show x12, show x6, show x2, show x7, show x3, show
    x5, show x13, show x11, show x9, show x1, show x14] info)
  _ -> failCons cd (consFail "EliminateCond._case_25" (showCons x14))

nd_C__case_25 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_25 x12 x6 x2 x7 x3 x5 x13 x11 x9 x1 x14 s cd cs = case x14 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_24 x6 x2 x7 x3 x5 x11 x9 x1 x13 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_25 x12 x6 x2 x7
    x3 x5 x13 x11 x9 x1 l s cd cs) (nd_C__case_25 x12 x6 x2 x7 x3 x5 x13 x11 x9
    x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_25 x12
    x6 x2 x7 x3 x5 x13 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_25 x12 x6 x2 x7
    x3 x5 x13 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_25" [show x12, show x6, show x2, show x7, show x3, show
    x5, show x13, show x11, show x9, show x1, show x14] info)
  _ -> failCons cd (consFail "EliminateCond._case_25" (showCons x14))

d_C__case_24 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_24 x6 x2 x7 x3 x5 x11 x9 x1 x13 cd cs = case x13 of
  Curry_Prelude.OP_Cons x14 x15 -> d_C__case_23 x14 x6 x2 x7 x3 x5 x15 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x14 (Curry_Prelude.C_Char 'r'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_24 x6 x2 x7 x3
    x5 x11 x9 x1 l cd cs) (d_C__case_24 x6 x2 x7 x3 x5 x11 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_24 x6
    x2 x7 x3 x5 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_24 x6 x2 x7 x3
    x5 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_24" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x13] info)
  _ -> failCons cd (consFail "EliminateCond._case_24" (showCons x13))

nd_C__case_24 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_24 x6 x2 x7 x3 x5 x11 x9 x1 x13 s cd cs = case x13 of
  Curry_Prelude.OP_Cons x14 x15 -> let s0 = s
    in s0 `seq` nd_C__case_23 x14 x6 x2 x7 x3 x5 x15 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x14 (Curry_Prelude.C_Char 'r'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_24 x6 x2 x7 x3
    x5 x11 x9 x1 l s cd cs) (nd_C__case_24 x6 x2 x7 x3 x5 x11 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_24 x6
    x2 x7 x3 x5 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_24 x6 x2 x7 x3
    x5 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_24" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x13] info)
  _ -> failCons cd (consFail "EliminateCond._case_24" (showCons x13))

d_C__case_23 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_23 x14 x6 x2 x7 x3 x5 x15 x11 x9 x1 x16 cd cs = case x16 of
  Curry_Prelude.C_True -> d_C__case_22 x6 x2 x7 x3 x5 x11 x9 x1 x15 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x14 x6 x2 x7
    x3 x5 x15 x11 x9 x1 l cd cs) (d_C__case_23 x14 x6 x2 x7 x3 x5 x15 x11 x9 x1
    r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x14
    x6 x2 x7 x3 x5 x15 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_23 x14 x6 x2 x7
    x3 x5 x15 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_23" [show x14, show x6, show x2, show x7, show x3, show
    x5, show x15, show x11, show x9, show x1, show x16] info)
  _ -> failCons cd (consFail "EliminateCond._case_23" (showCons x16))

nd_C__case_23 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_23 x14 x6 x2 x7 x3 x5 x15 x11 x9 x1 x16 s cd cs = case x16 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_22 x6 x2 x7 x3 x5 x11 x9 x1 x15 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_23 x14 x6 x2 x7
    x3 x5 x15 x11 x9 x1 l s cd cs) (nd_C__case_23 x14 x6 x2 x7 x3 x5 x15 x11 x9
    x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_23 x14
    x6 x2 x7 x3 x5 x15 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_23 x14 x6 x2 x7
    x3 x5 x15 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_23" [show x14, show x6, show x2, show x7, show x3, show
    x5, show x15, show x11, show x9, show x1, show x16] info)
  _ -> failCons cd (consFail "EliminateCond._case_23" (showCons x16))

d_C__case_22 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_22 x6 x2 x7 x3 x5 x11 x9 x1 x15 cd cs = case x15 of
  Curry_Prelude.OP_Cons x16 x17 -> d_C__case_21 x16 x6 x2 x7 x3 x5 x17 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x16 (Curry_Prelude.C_Char 'e'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_22 x6 x2 x7 x3
    x5 x11 x9 x1 l cd cs) (d_C__case_22 x6 x2 x7 x3 x5 x11 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_22 x6
    x2 x7 x3 x5 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_22 x6 x2 x7 x3
    x5 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_22" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x15] info)
  _ -> failCons cd (consFail "EliminateCond._case_22" (showCons x15))

nd_C__case_22 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_22 x6 x2 x7 x3 x5 x11 x9 x1 x15 s cd cs = case x15 of
  Curry_Prelude.OP_Cons x16 x17 -> let s0 = s
    in s0 `seq` nd_C__case_21 x16 x6 x2 x7 x3 x5 x17 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x16 (Curry_Prelude.C_Char 'e'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_22 x6 x2 x7 x3
    x5 x11 x9 x1 l s cd cs) (nd_C__case_22 x6 x2 x7 x3 x5 x11 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_22 x6
    x2 x7 x3 x5 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_22 x6 x2 x7 x3
    x5 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_22" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x15] info)
  _ -> failCons cd (consFail "EliminateCond._case_22" (showCons x15))

d_C__case_21 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_21 x16 x6 x2 x7 x3 x5 x17 x11 x9 x1 x18 cd cs = case x18 of
  Curry_Prelude.C_True -> d_C__case_20 x6 x2 x7 x3 x5 x11 x9 x1 x17 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x16 x6 x2 x7
    x3 x5 x17 x11 x9 x1 l cd cs) (d_C__case_21 x16 x6 x2 x7 x3 x5 x17 x11 x9 x1
    r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x16
    x6 x2 x7 x3 x5 x17 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_21 x16 x6 x2 x7
    x3 x5 x17 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_21" [show x16, show x6, show x2, show x7, show x3, show
    x5, show x17, show x11, show x9, show x1, show x18] info)
  _ -> failCons cd (consFail "EliminateCond._case_21" (showCons x18))

nd_C__case_21 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_21 x16 x6 x2 x7 x3 x5 x17 x11 x9 x1 x18 s cd cs = case x18 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_20 x6 x2 x7 x3 x5 x11 x9 x1 x17 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_21 x16 x6 x2 x7
    x3 x5 x17 x11 x9 x1 l s cd cs) (nd_C__case_21 x16 x6 x2 x7 x3 x5 x17 x11 x9
    x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_21 x16
    x6 x2 x7 x3 x5 x17 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_21 x16 x6 x2 x7
    x3 x5 x17 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_21" [show x16, show x6, show x2, show x7, show x3, show
    x5, show x17, show x11, show x9, show x1, show x18] info)
  _ -> failCons cd (consFail "EliminateCond._case_21" (showCons x18))

d_C__case_20 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_20 x6 x2 x7 x3 x5 x11 x9 x1 x17 cd cs = case x17 of
  Curry_Prelude.OP_Cons x18 x19 -> d_C__case_19 x18 x6 x2 x7 x3 x5 x19 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x18 (Curry_Prelude.C_Char 'l'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_20 x6 x2 x7 x3
    x5 x11 x9 x1 l cd cs) (d_C__case_20 x6 x2 x7 x3 x5 x11 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_20 x6
    x2 x7 x3 x5 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_20 x6 x2 x7 x3
    x5 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_20" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x17] info)
  _ -> failCons cd (consFail "EliminateCond._case_20" (showCons x17))

nd_C__case_20 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_20 x6 x2 x7 x3 x5 x11 x9 x1 x17 s cd cs = case x17 of
  Curry_Prelude.OP_Cons x18 x19 -> let s0 = s
    in s0 `seq` nd_C__case_19 x18 x6 x2 x7 x3 x5 x19 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x18 (Curry_Prelude.C_Char 'l'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_20 x6 x2 x7 x3
    x5 x11 x9 x1 l s cd cs) (nd_C__case_20 x6 x2 x7 x3 x5 x11 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_20 x6
    x2 x7 x3 x5 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_20 x6 x2 x7 x3
    x5 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_20" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x17] info)
  _ -> failCons cd (consFail "EliminateCond._case_20" (showCons x17))

d_C__case_19 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_19 x18 x6 x2 x7 x3 x5 x19 x11 x9 x1 x20 cd cs = case x20 of
  Curry_Prelude.C_True -> d_C__case_18 x6 x2 x7 x3 x5 x11 x9 x1 x19 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x18 x6 x2 x7
    x3 x5 x19 x11 x9 x1 l cd cs) (d_C__case_19 x18 x6 x2 x7 x3 x5 x19 x11 x9 x1
    r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x18
    x6 x2 x7 x3 x5 x19 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_19 x18 x6 x2 x7
    x3 x5 x19 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_19" [show x18, show x6, show x2, show x7, show x3, show
    x5, show x19, show x11, show x9, show x1, show x20] info)
  _ -> failCons cd (consFail "EliminateCond._case_19" (showCons x20))

nd_C__case_19 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_19 x18 x6 x2 x7 x3 x5 x19 x11 x9 x1 x20 s cd cs = case x20 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_18 x6 x2 x7 x3 x5 x11 x9 x1 x19 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_19 x18 x6 x2 x7
    x3 x5 x19 x11 x9 x1 l s cd cs) (nd_C__case_19 x18 x6 x2 x7 x3 x5 x19 x11 x9
    x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_19 x18
    x6 x2 x7 x3 x5 x19 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_19 x18 x6 x2 x7
    x3 x5 x19 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_19" [show x18, show x6, show x2, show x7, show x3, show
    x5, show x19, show x11, show x9, show x1, show x20] info)
  _ -> failCons cd (consFail "EliminateCond._case_19" (showCons x20))

d_C__case_18 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_18 x6 x2 x7 x3 x5 x11 x9 x1 x19 cd cs = case x19 of
  Curry_Prelude.OP_Cons x20 x21 -> d_C__case_17 x20 x6 x2 x7 x3 x5 x21 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x20 (Curry_Prelude.C_Char 'u'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_18 x6 x2 x7 x3
    x5 x11 x9 x1 l cd cs) (d_C__case_18 x6 x2 x7 x3 x5 x11 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_18 x6
    x2 x7 x3 x5 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_18 x6 x2 x7 x3
    x5 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_18" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x19] info)
  _ -> failCons cd (consFail "EliminateCond._case_18" (showCons x19))

nd_C__case_18 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_18 x6 x2 x7 x3 x5 x11 x9 x1 x19 s cd cs = case x19 of
  Curry_Prelude.OP_Cons x20 x21 -> let s0 = s
    in s0 `seq` nd_C__case_17 x20 x6 x2 x7 x3 x5 x21 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x20 (Curry_Prelude.C_Char 'u'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_18 x6 x2 x7 x3
    x5 x11 x9 x1 l s cd cs) (nd_C__case_18 x6 x2 x7 x3 x5 x11 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_18 x6
    x2 x7 x3 x5 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_18 x6 x2 x7 x3
    x5 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_18" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x19] info)
  _ -> failCons cd (consFail "EliminateCond._case_18" (showCons x19))

d_C__case_17 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_17 x20 x6 x2 x7 x3 x5 x21 x11 x9 x1 x22 cd cs = case x22 of
  Curry_Prelude.C_True -> d_C__case_16 x6 x2 x7 x3 x5 x11 x9 x1 x21 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x20 x6 x2 x7
    x3 x5 x21 x11 x9 x1 l cd cs) (d_C__case_17 x20 x6 x2 x7 x3 x5 x21 x11 x9 x1
    r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x20
    x6 x2 x7 x3 x5 x21 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_17 x20 x6 x2 x7
    x3 x5 x21 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_17" [show x20, show x6, show x2, show x7, show x3, show
    x5, show x21, show x11, show x9, show x1, show x22] info)
  _ -> failCons cd (consFail "EliminateCond._case_17" (showCons x22))

nd_C__case_17 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_17 x20 x6 x2 x7 x3 x5 x21 x11 x9 x1 x22 s cd cs = case x22 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_16 x6 x2 x7 x3 x5 x11 x9 x1 x21 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_17 x20 x6 x2 x7
    x3 x5 x21 x11 x9 x1 l s cd cs) (nd_C__case_17 x20 x6 x2 x7 x3 x5 x21 x11 x9
    x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_17 x20
    x6 x2 x7 x3 x5 x21 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_17 x20 x6 x2 x7
    x3 x5 x21 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_17" [show x20, show x6, show x2, show x7, show x3, show
    x5, show x21, show x11, show x9, show x1, show x22] info)
  _ -> failCons cd (consFail "EliminateCond._case_17" (showCons x22))

d_C__case_16 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_16 x6 x2 x7 x3 x5 x11 x9 x1 x21 cd cs = case x21 of
  Curry_Prelude.OP_Cons x22 x23 -> d_C__case_15 x22 x6 x2 x7 x3 x5 x23 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x22 (Curry_Prelude.C_Char 'd'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_16 x6 x2 x7 x3
    x5 x11 x9 x1 l cd cs) (d_C__case_16 x6 x2 x7 x3 x5 x11 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_16 x6
    x2 x7 x3 x5 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_16 x6 x2 x7 x3
    x5 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_16" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x21] info)
  _ -> failCons cd (consFail "EliminateCond._case_16" (showCons x21))

nd_C__case_16 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_16 x6 x2 x7 x3 x5 x11 x9 x1 x21 s cd cs = case x21 of
  Curry_Prelude.OP_Cons x22 x23 -> let s0 = s
    in s0 `seq` nd_C__case_15 x22 x6 x2 x7 x3 x5 x23 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x22 (Curry_Prelude.C_Char 'd'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_16 x6 x2 x7 x3
    x5 x11 x9 x1 l s cd cs) (nd_C__case_16 x6 x2 x7 x3 x5 x11 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_16 x6
    x2 x7 x3 x5 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_16 x6 x2 x7 x3
    x5 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_16" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x21] info)
  _ -> failCons cd (consFail "EliminateCond._case_16" (showCons x21))

d_C__case_15 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_15 x22 x6 x2 x7 x3 x5 x23 x11 x9 x1 x24 cd cs = case x24 of
  Curry_Prelude.C_True -> d_C__case_14 x6 x2 x7 x3 x5 x11 x9 x1 x23 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x22 x6 x2 x7
    x3 x5 x23 x11 x9 x1 l cd cs) (d_C__case_15 x22 x6 x2 x7 x3 x5 x23 x11 x9 x1
    r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x22
    x6 x2 x7 x3 x5 x23 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_15 x22 x6 x2 x7
    x3 x5 x23 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_15" [show x22, show x6, show x2, show x7, show x3, show
    x5, show x23, show x11, show x9, show x1, show x24] info)
  _ -> failCons cd (consFail "EliminateCond._case_15" (showCons x24))

nd_C__case_15 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_15 x22 x6 x2 x7 x3 x5 x23 x11 x9 x1 x24 s cd cs = case x24 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_14 x6 x2 x7 x3 x5 x11 x9 x1 x23 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_15 x22 x6 x2 x7
    x3 x5 x23 x11 x9 x1 l s cd cs) (nd_C__case_15 x22 x6 x2 x7 x3 x5 x23 x11 x9
    x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_15 x22
    x6 x2 x7 x3 x5 x23 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_15 x22 x6 x2 x7
    x3 x5 x23 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_15" [show x22, show x6, show x2, show x7, show x3, show
    x5, show x23, show x11, show x9, show x1, show x24] info)
  _ -> failCons cd (consFail "EliminateCond._case_15" (showCons x24))

d_C__case_14 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_14 x6 x2 x7 x3 x5 x11 x9 x1 x23 cd cs = case x23 of
  Curry_Prelude.OP_Cons x24 x25 -> d_C__case_13 x24 x6 x2 x7 x3 x5 x25 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x24 (Curry_Prelude.C_Char 'e'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_14 x6 x2 x7 x3
    x5 x11 x9 x1 l cd cs) (d_C__case_14 x6 x2 x7 x3 x5 x11 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_14 x6
    x2 x7 x3 x5 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_14 x6 x2 x7 x3
    x5 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_14" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x23] info)
  _ -> failCons cd (consFail "EliminateCond._case_14" (showCons x23))

nd_C__case_14 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_14 x6 x2 x7 x3 x5 x11 x9 x1 x23 s cd cs = case x23 of
  Curry_Prelude.OP_Cons x24 x25 -> let s0 = s
    in s0 `seq` nd_C__case_13 x24 x6 x2 x7 x3 x5 x25 x11 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x24 (Curry_Prelude.C_Char 'e'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_14 x6 x2 x7 x3
    x5 x11 x9 x1 l s cd cs) (nd_C__case_14 x6 x2 x7 x3 x5 x11 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_14 x6
    x2 x7 x3 x5 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_14 x6 x2 x7 x3
    x5 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_14" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x23] info)
  _ -> failCons cd (consFail "EliminateCond._case_14" (showCons x23))

d_C__case_13 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_13 x24 x6 x2 x7 x3 x5 x25 x11 x9 x1 x26 cd cs = case x26 of
  Curry_Prelude.C_True -> d_C__case_12 x6 x2 x7 x3 x5 x11 x9 x1 x25 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x24 x6 x2 x7
    x3 x5 x25 x11 x9 x1 l cd cs) (d_C__case_13 x24 x6 x2 x7 x3 x5 x25 x11 x9 x1
    r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x24
    x6 x2 x7 x3 x5 x25 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_13 x24 x6 x2 x7
    x3 x5 x25 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_13" [show x24, show x6, show x2, show x7, show x3, show
    x5, show x25, show x11, show x9, show x1, show x26] info)
  _ -> failCons cd (consFail "EliminateCond._case_13" (showCons x26))

nd_C__case_13 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_13 x24 x6 x2 x7 x3 x5 x25 x11 x9 x1 x26 s cd cs = case x26 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_12 x6 x2 x7 x3 x5 x11 x9 x1 x25 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_13 x24 x6 x2 x7
    x3 x5 x25 x11 x9 x1 l s cd cs) (nd_C__case_13 x24 x6 x2 x7 x3 x5 x25 x11 x9
    x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_13 x24
    x6 x2 x7 x3 x5 x25 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_13 x24 x6 x2 x7
    x3 x5 x25 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_13" [show x24, show x6, show x2, show x7, show x3, show
    x5, show x25, show x11, show x9, show x1, show x26] info)
  _ -> failCons cd (consFail "EliminateCond._case_13" (showCons x26))

d_C__case_12 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_12 x6 x2 x7 x3 x5 x11 x9 x1 x25 cd cs = case x25 of
  Curry_Prelude.OP_List -> d_C__case_11 x6 x2 x7 x3 x5 x9 x1 x11 cd cs
  Curry_Prelude.OP_Cons x42 x43 -> Curry_State.d_C_bindS
    (Curry_Prelude.d_C_apply (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_12 x6 x2 x7 x3
    x5 x11 x9 x1 l cd cs) (d_C__case_12 x6 x2 x7 x3 x5 x11 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_12 x6
    x2 x7 x3 x5 x11 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_12 x6 x2 x7 x3
    x5 x11 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_12" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x25] info)
  _ -> failCons cd (consFail "EliminateCond._case_12" (showCons x25))

nd_C__case_12 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_12 x6 x2 x7 x3 x5 x11 x9 x1 x25 s cd cs = case x25 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C__case_11 x6 x2 x7 x3 x5 x9 x1 x11 s0 cd cs
  Curry_Prelude.OP_Cons x42 x43 -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_12 x6 x2 x7 x3
    x5 x11 x9 x1 l s cd cs) (nd_C__case_12 x6 x2 x7 x3 x5 x11 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_12 x6
    x2 x7 x3 x5 x11 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_12 x6 x2 x7 x3
    x5 x11 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_12" [show x6, show x2, show x7, show x3, show x5, show
    x11, show x9, show x1, show x25] info)
  _ -> failCons cd (consFail "EliminateCond._case_12" (showCons x25))

d_C__case_11 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_11 x6 x2 x7 x3 x5 x9 x1 x11 cd cs = case x11 of
  Curry_Prelude.OP_Cons x26 x27 -> d_C__case_10 x26 x6 x2 x7 x3 x5 x27 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x26 (Curry_Prelude.C_Char 'c'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_11 x6 x2 x7 x3
    x5 x9 x1 l cd cs) (d_C__case_11 x6 x2 x7 x3 x5 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_11 x6
    x2 x7 x3 x5 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_11 x6 x2 x7 x3
    x5 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_11" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x11] info)
  _ -> failCons cd (consFail "EliminateCond._case_11" (showCons x11))

nd_C__case_11 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_11 x6 x2 x7 x3 x5 x9 x1 x11 s cd cs = case x11 of
  Curry_Prelude.OP_Cons x26 x27 -> let s0 = s
    in s0 `seq` nd_C__case_10 x26 x6 x2 x7 x3 x5 x27 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x26 (Curry_Prelude.C_Char 'c'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_11 x6 x2 x7 x3
    x5 x9 x1 l s cd cs) (nd_C__case_11 x6 x2 x7 x3 x5 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_11 x6
    x2 x7 x3 x5 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_11 x6 x2 x7 x3
    x5 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_11" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x11] info)
  _ -> failCons cd (consFail "EliminateCond._case_11" (showCons x11))

d_C__case_10 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_10 x26 x6 x2 x7 x3 x5 x27 x9 x1 x28 cd cs = case x28 of
  Curry_Prelude.C_True -> d_C__case_9 x6 x2 x7 x3 x5 x9 x1 x27 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x26 x6 x2 x7
    x3 x5 x27 x9 x1 l cd cs) (d_C__case_10 x26 x6 x2 x7 x3 x5 x27 x9 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x26
    x6 x2 x7 x3 x5 x27 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_10 x26 x6 x2 x7
    x3 x5 x27 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_10" [show x26, show x6, show x2, show x7, show x3, show
    x5, show x27, show x9, show x1, show x28] info)
  _ -> failCons cd (consFail "EliminateCond._case_10" (showCons x28))

nd_C__case_10 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_10 x26 x6 x2 x7 x3 x5 x27 x9 x1 x28 s cd cs = case x28 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_9 x6 x2 x7 x3 x5 x9 x1 x27 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_10 x26 x6 x2 x7
    x3 x5 x27 x9 x1 l s cd cs) (nd_C__case_10 x26 x6 x2 x7 x3 x5 x27 x9 x1 r s
    cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_10 x26
    x6 x2 x7 x3 x5 x27 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_10 x26 x6 x2 x7
    x3 x5 x27 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_10" [show x26, show x6, show x2, show x7, show x3, show
    x5, show x27, show x9, show x1, show x28] info)
  _ -> failCons cd (consFail "EliminateCond._case_10" (showCons x28))

d_C__case_9 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_9 x6 x2 x7 x3 x5 x9 x1 x27 cd cs = case x27 of
  Curry_Prelude.OP_Cons x28 x29 -> d_C__case_8 x28 x6 x2 x7 x3 x5 x29 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x28 (Curry_Prelude.C_Char 'o'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_9 x6 x2 x7 x3 x5
    x9 x1 l cd cs) (d_C__case_9 x6 x2 x7 x3 x5 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_9 x6
    x2 x7 x3 x5 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_9 x6 x2 x7 x3 x5
    x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_9" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x27] info)
  _ -> failCons cd (consFail "EliminateCond._case_9" (showCons x27))

nd_C__case_9 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_9 x6 x2 x7 x3 x5 x9 x1 x27 s cd cs = case x27 of
  Curry_Prelude.OP_Cons x28 x29 -> let s0 = s
    in s0 `seq` nd_C__case_8 x28 x6 x2 x7 x3 x5 x29 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x28 (Curry_Prelude.C_Char 'o'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_9 x6 x2 x7 x3
    x5 x9 x1 l s cd cs) (nd_C__case_9 x6 x2 x7 x3 x5 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_9 x6
    x2 x7 x3 x5 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_9 x6 x2 x7 x3
    x5 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_9" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x27] info)
  _ -> failCons cd (consFail "EliminateCond._case_9" (showCons x27))

d_C__case_8 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_8 x28 x6 x2 x7 x3 x5 x29 x9 x1 x30 cd cs = case x30 of
  Curry_Prelude.C_True -> d_C__case_7 x6 x2 x7 x3 x5 x9 x1 x29 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x28 x6 x2 x7 x3
    x5 x29 x9 x1 l cd cs) (d_C__case_8 x28 x6 x2 x7 x3 x5 x29 x9 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x28
    x6 x2 x7 x3 x5 x29 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_8 x28 x6 x2 x7 x3
    x5 x29 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_8" [show x28, show x6, show x2, show x7, show x3, show
    x5, show x29, show x9, show x1, show x30] info)
  _ -> failCons cd (consFail "EliminateCond._case_8" (showCons x30))

nd_C__case_8 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_8 x28 x6 x2 x7 x3 x5 x29 x9 x1 x30 s cd cs = case x30 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_7 x6 x2 x7 x3 x5 x9 x1 x29 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_8 x28 x6 x2 x7
    x3 x5 x29 x9 x1 l s cd cs) (nd_C__case_8 x28 x6 x2 x7 x3 x5 x29 x9 x1 r s cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_8 x28
    x6 x2 x7 x3 x5 x29 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_8 x28 x6 x2 x7
    x3 x5 x29 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_8" [show x28, show x6, show x2, show x7, show x3, show
    x5, show x29, show x9, show x1, show x30] info)
  _ -> failCons cd (consFail "EliminateCond._case_8" (showCons x30))

d_C__case_7 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_7 x6 x2 x7 x3 x5 x9 x1 x29 cd cs = case x29 of
  Curry_Prelude.OP_Cons x30 x31 -> d_C__case_6 x30 x6 x2 x7 x3 x5 x31 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x30 (Curry_Prelude.C_Char 'n'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_7 x6 x2 x7 x3 x5
    x9 x1 l cd cs) (d_C__case_7 x6 x2 x7 x3 x5 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_7 x6
    x2 x7 x3 x5 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_7 x6 x2 x7 x3 x5
    x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_7" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x29] info)
  _ -> failCons cd (consFail "EliminateCond._case_7" (showCons x29))

nd_C__case_7 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_7 x6 x2 x7 x3 x5 x9 x1 x29 s cd cs = case x29 of
  Curry_Prelude.OP_Cons x30 x31 -> let s0 = s
    in s0 `seq` nd_C__case_6 x30 x6 x2 x7 x3 x5 x31 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x30 (Curry_Prelude.C_Char 'n'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_7 x6 x2 x7 x3
    x5 x9 x1 l s cd cs) (nd_C__case_7 x6 x2 x7 x3 x5 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_7 x6
    x2 x7 x3 x5 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_7 x6 x2 x7 x3
    x5 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_7" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x29] info)
  _ -> failCons cd (consFail "EliminateCond._case_7" (showCons x29))

d_C__case_6 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_6 x30 x6 x2 x7 x3 x5 x31 x9 x1 x32 cd cs = case x32 of
  Curry_Prelude.C_True -> d_C__case_5 x6 x2 x7 x3 x5 x9 x1 x31 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x30 x6 x2 x7 x3
    x5 x31 x9 x1 l cd cs) (d_C__case_6 x30 x6 x2 x7 x3 x5 x31 x9 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x30
    x6 x2 x7 x3 x5 x31 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_6 x30 x6 x2 x7 x3
    x5 x31 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_6" [show x30, show x6, show x2, show x7, show x3, show
    x5, show x31, show x9, show x1, show x32] info)
  _ -> failCons cd (consFail "EliminateCond._case_6" (showCons x32))

nd_C__case_6 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_6 x30 x6 x2 x7 x3 x5 x31 x9 x1 x32 s cd cs = case x32 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_5 x6 x2 x7 x3 x5 x9 x1 x31 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_6 x30 x6 x2 x7
    x3 x5 x31 x9 x1 l s cd cs) (nd_C__case_6 x30 x6 x2 x7 x3 x5 x31 x9 x1 r s cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_6 x30
    x6 x2 x7 x3 x5 x31 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_6 x30 x6 x2 x7
    x3 x5 x31 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_6" [show x30, show x6, show x2, show x7, show x3, show
    x5, show x31, show x9, show x1, show x32] info)
  _ -> failCons cd (consFail "EliminateCond._case_6" (showCons x32))

d_C__case_5 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_5 x6 x2 x7 x3 x5 x9 x1 x31 cd cs = case x31 of
  Curry_Prelude.OP_Cons x32 x33 -> d_C__case_4 x32 x6 x2 x7 x3 x5 x33 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x32 (Curry_Prelude.C_Char 'd'#) cd cs) cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_5 x6 x2 x7 x3 x5
    x9 x1 l cd cs) (d_C__case_5 x6 x2 x7 x3 x5 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_5 x6
    x2 x7 x3 x5 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_5 x6 x2 x7 x3 x5
    x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_5" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x31] info)
  _ -> failCons cd (consFail "EliminateCond._case_5" (showCons x31))

nd_C__case_5 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_5 x6 x2 x7 x3 x5 x9 x1 x31 s cd cs = case x31 of
  Curry_Prelude.OP_Cons x32 x33 -> let s0 = s
    in s0 `seq` nd_C__case_4 x32 x6 x2 x7 x3 x5 x33 x9 x1
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char
    x32 (Curry_Prelude.C_Char 'd'#) cd cs) s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_5 x6 x2 x7 x3
    x5 x9 x1 l s cd cs) (nd_C__case_5 x6 x2 x7 x3 x5 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_5 x6
    x2 x7 x3 x5 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_5 x6 x2 x7 x3
    x5 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_5" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x31] info)
  _ -> failCons cd (consFail "EliminateCond._case_5" (showCons x31))

d_C__case_4 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_4 x32 x6 x2 x7 x3 x5 x33 x9 x1 x34 cd cs = case x34 of
  Curry_Prelude.C_True -> d_C__case_3 x6 x2 x7 x3 x5 x9 x1 x33 cd cs
  Curry_Prelude.C_False -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x32 x6 x2 x7 x3
    x5 x33 x9 x1 l cd cs) (d_C__case_4 x32 x6 x2 x7 x3 x5 x33 x9 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x32
    x6 x2 x7 x3 x5 x33 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_4 x32 x6 x2 x7 x3
    x5 x33 x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_4" [show x32, show x6, show x2, show x7, show x3, show
    x5, show x33, show x9, show x1, show x34] info)
  _ -> failCons cd (consFail "EliminateCond._case_4" (showCons x34))

nd_C__case_4 :: Curry_Prelude.C_Char -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_4 x32 x6 x2 x7 x3 x5 x33 x9 x1 x34 s cd cs = case x34 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` nd_C__case_3 x6 x2 x7 x3 x5 x9 x1 x33 s0 cd cs
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x32 x6 x2 x7
    x3 x5 x33 x9 x1 l s cd cs) (nd_C__case_4 x32 x6 x2 x7 x3 x5 x33 x9 x1 r s cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x32
    x6 x2 x7 x3 x5 x33 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_4 x32 x6 x2 x7
    x3 x5 x33 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "EliminateCond._case_4" [show x32, show x6, show x2, show x7, show x3, show
    x5, show x33, show x9, show x1, show x34] info)
  _ -> failCons cd (consFail "EliminateCond._case_4" (showCons x34))

d_C__case_3 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_3 x6 x2 x7 x3 x5 x9 x1 x33 cd cs = case x33 of
  Curry_Prelude.OP_List -> d_C__case_2 x6 x2 x7 x3 x5 x1 x9 cd cs
  Curry_Prelude.OP_Cons x40 x41 -> Curry_State.d_C_bindS
    (Curry_Prelude.d_C_apply (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x6 x2 x7 x3 x5
    x9 x1 l cd cs) (d_C__case_3 x6 x2 x7 x3 x5 x9 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x6
    x2 x7 x3 x5 x9 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_3 x6 x2 x7 x3 x5
    x9 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_3" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x33] info)
  _ -> failCons cd (consFail "EliminateCond._case_3" (showCons x33))

nd_C__case_3 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_3 x6 x2 x7 x3 x5 x9 x1 x33 s cd cs = case x33 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` nd_C__case_2 x6 x2 x7 x3 x5 x1 x9 s0 cd cs
  Curry_Prelude.OP_Cons x40 x41 -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_3 x6 x2 x7 x3
    x5 x9 x1 l s cd cs) (nd_C__case_3 x6 x2 x7 x3 x5 x9 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_3 x6
    x2 x7 x3 x5 x9 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_3 x6 x2 x7 x3
    x5 x9 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_3" [show x6, show x2, show x7, show x3, show x5, show
    x9, show x1, show x33] info)
  _ -> failCons cd (consFail "EliminateCond._case_3" (showCons x33))

d_C__case_2 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_2 x6 x2 x7 x3 x5 x1 x9 cd cs = case x9 of
  Curry_Prelude.OP_Cons x34 x35 -> d_C__case_1 x6 x2 x7 x3 x5 x1 x34 x35 cd cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x6 x2 x7 x3 x5
    x1 l cd cs) (d_C__case_2 x6 x2 x7 x3 x5 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x6
    x2 x7 x3 x5 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_2 x6 x2 x7 x3 x5
    x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_2" [show x6, show x2, show x7, show x3, show x5, show
    x1, show x9] info)
  _ -> failCons cd (consFail "EliminateCond._case_2" (showCons x9))

nd_C__case_2 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_2 x6 x2 x7 x3 x5 x1 x9 s cd cs = case x9 of
  Curry_Prelude.OP_Cons x34 x35 -> let s0 = s
    in s0 `seq` nd_C__case_1 x6 x2 x7 x3 x5 x1 x34 x35 s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_2 x6 x2 x7 x3
    x5 x1 l s cd cs) (nd_C__case_2 x6 x2 x7 x3 x5 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_2 x6
    x2 x7 x3 x5 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_2 x6 x2 x7 x3
    x5 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_2" [show x6, show x2, show x7, show x3, show x5, show
    x1, show x9] info)
  _ -> failCons cd (consFail "EliminateCond._case_2" (showCons x9))

d_C__case_1 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_1 x6 x2 x7 x3 x5 x1 x34 x35 cd cs = case x35 of
  Curry_Prelude.OP_Cons x36 x37 -> d_C__case_0 x6 x2 x7 x3 x5 x36 x1 x34 x37 cd
    cs
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS (Curry_Prelude.d_C_apply
    (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_1 x6 x2 x7 x3 x5
    x1 x34 l cd cs) (d_C__case_1 x6 x2 x7 x3 x5 x1 x34 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_1 x6
    x2 x7 x3 x5 x1 x34 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_1 x6 x2 x7 x3 x5
    x1 x34 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_1" [show x6, show x2, show x7, show x3, show x5, show
    x1, show x34, show x35] info)
  _ -> failCons cd (consFail "EliminateCond._case_1" (showCons x35))

nd_C__case_1 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_1 x6 x2 x7 x3 x5 x1 x34 x35 s cd cs = case x35 of
  Curry_Prelude.OP_Cons x36 x37 -> let s0 = s
    in s0 `seq` nd_C__case_0 x6 x2 x7 x3 x5 x36 x1 x34 x37 s0 cd cs
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_1 x6 x2 x7 x3
    x5 x1 x34 l s cd cs) (nd_C__case_1 x6 x2 x7 x3 x5 x1 x34 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_1 x6
    x2 x7 x3 x5 x1 x34 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_1 x6 x2 x7 x3
    x5 x1 x34 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_1" [show x6, show x2, show x7, show x3, show x5, show
    x1, show x34, show x35] info)
  _ -> failCons cd (consFail "EliminateCond._case_1" (showCons x35))

d_C__case_0 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
d_C__case_0 x6 x2 x7 x3 x5 x36 x1 x34 x37 cd cs = case x37 of
  Curry_Prelude.OP_List -> Curry_State.d_C_bindS x34
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2 x2 x1 x36)
  Curry_Prelude.OP_Cons x38 x39 -> Curry_State.d_C_bindS
    (Curry_Prelude.d_C_apply (Curry_State.d_C_sequenceS cd cs) x5 cd cs)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x6 x2 x7 x3 x5
    x36 x1 x34 l cd cs) (d_C__case_0 x6 x2 x7 x3 x5 x36 x1 x34 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x6
    x2 x7 x3 x5 x36 x1 x34 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_0 x6 x2 x7 x3 x5
    x36 x1 x34 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_0" [show x6, show x2, show x7, show x3, show x5, show
    x36, show x1, show x34, show x37] info)
  _ -> failCons cd (consFail "EliminateCond._case_0" (showCons x37))

nd_C__case_0 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_List (Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))) -> Func
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
  -> Curry_Prelude.OP_List (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int))
nd_C__case_0 x6 x2 x7 x3 x5 x36 x1 x34 x37 s cd cs = case x37 of
  Curry_Prelude.OP_List -> wrapNX id (Curry_State.nd_C_bindS x34 (wrapNX id
    (nd_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda2 x2 x1 x36)))
  Curry_Prelude.OP_Cons x38 x39 -> let s2 = s
    in s2 `seq` wrapNX id (Curry_State.nd_C_bindS (let s1 = leftSupply s2
                                                       s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_State.nd_C_sequenceS
    s0 cd cs) x5 s1 cd cs)) (wrapDX (wrapDX id)
    (d_OP_transExpr_dot_transComb_dot_17_dot_uscore_hash_lambda4 x3 x7 x2 x6)))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_0 x6 x2 x7 x3
    x5 x36 x1 x34 l s cd cs) (nd_C__case_0 x6 x2 x7 x3 x5 x36 x1 x34 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_0 x6
    x2 x7 x3 x5 x36 x1 x34 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_0 x6 x2 x7 x3
    x5 x36 x1 x34 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "EliminateCond._case_0" [show x6, show x2, show x7, show x3, show x5, show
    x36, show x1, show x34, show x37] info)
  _ -> failCons cd (consFail "EliminateCond._case_0" (showCons x37))

d_C__case_29 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_29 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_29 l cd cs)
    (d_C__case_29 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_29 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_29 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond._case_29" [show x3] info)
  _ -> failCons cd (consFail "EliminateCond._case_29" (showCons x3))

d_C__case_30 :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) Curry_Prelude.C_Int -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
d_C__case_30 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_30 x2 l cd cs)
    (d_C__case_30 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_30
    x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_30 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "EliminateCond._case_30" [show x2, show x3] info)
  _ -> failCons cd (consFail "EliminateCond._case_30" (showCons x3))

d_C__case_31 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Curry_Types.C_Visibility
  -> Curry_Prelude.C_Int -> FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_31 x2 x5 x4 x3 x1 x6 cd cs = case x6 of
  FlatCurry.Annotated.Curry_Types.C_AExternal x7 x8 -> Curry_Prelude.OP_Cons x1
    Curry_Prelude.OP_List
  FlatCurry.Annotated.Curry_Types.C_ARule x9 x10 x11 -> let x12 = Curry_State.d_C_runState
                                                              (d_C_transExpr x2
                                                              x11 cd cs)
                                                              (Curry_Prelude.OP_Tuple2
                                                              Curry_Prelude.OP_List
                                                              (Curry_Prelude.C_Int
                                                              (0))) cd cs
                                                            x13 = d_OP_transFunc_dot_uscore_hash_selFP2_hash_e_tick
                                                              x12 cd cs
                                                            x14 = d_OP_transFunc_dot_uscore_hash_selFP3_hash_newFuns
                                                              x12 cd cs
    in Curry_Prelude.OP_Cons (FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4
    x5 (FlatCurry.Annotated.Curry_Types.C_ARule x9 x10 x13)) x14
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (d_C__case_31 x2 x5 x4 x3 x1 l cd cs) (d_C__case_31 x2 x5 x4 x3 x1 r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> d_C__case_31 x2 x5 x4 x3 x1 z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (d_C__case_31 x2 x5 x4 x3 x1 e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "EliminateCond._case_31" [show x2, show x5, show x4, show x3, show x1, show
    x6] info)
  _ -> failCons cd (consFail "EliminateCond._case_31" (showCons x6))

